<?php

/* this file has been generated automatically; do not edit */

/**
 * @package Lasso
 */

// Try to load Lasso extension if it's not already loaded.
if (!extension_loaded('lasso')) {
    die("Lasso extension is not loaded");
}

/*
 * Convert a C object to a PHP object
 */
function cptrToPhp ($cptr) {
    if (is_null($cptr) || !$cptr) return null;
    $typename = lasso_get_object_typename($cptr);
    $class_name = $typename . "NoInit";
    $obj = new $class_name(); 
    if (! is_null($obj)) {
        $obj->_cptr = $cptr;
        return $obj;
    }
    return null;
}

function lassoGetRequestTypeFromSoapMsg($mesg) {
    return lasso_get_request_type_from_soap_msg($mesg);
}

function lassoRegisterIdWsf2DstService($prefix, $href) {
    lasso_register_idwsf2_dst_service($prefix, $href);
}

/**
 * @package Lasso
 */
class LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_node_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoNode  failed "); }
    }

    public static function newFromDump($dump) {
        return cptrToPhp(lasso_node_new_from_dump($dump));
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * Dumps $this.  All datas in object are dumped in an XML format.
     * 
     * @return string a full XML dump of $this.  The string must be freed by the
     *     caller.
     */
    public function dump() {
        return lasso_node_dump($this->_cptr);
    }

    /**
     * Exports $this to a base64-encoded message.
     * 
     * @return string a base64-encoded export of $this.  The string must be freed by
     *      the caller.
     */
    public function exportToBase64() {
        return lasso_node_export_to_base64($this->_cptr);
    }

    /**
     * Exports $this to a HTTP query string.  If $private_key_file is NULL,
     * query won't be signed.
     * 
     * @return string a HTTP query export of $this.  The string must be freed by the
     *      caller.
     */
    public function exportToQuery($sign_method, $private_key_file) {
        return lasso_node_export_to_query($this->_cptr, $sign_method, $private_key_file);
    }

    /**
     * Exports $this to a SOAP message.
     * 
     * @return string a SOAP export of $this.  The string must be freed by the
     *      caller.
     */
    public function exportToSoap() {
        return lasso_node_export_to_soap($this->_cptr);
    }

    /**
     * Exports $this to an xml message.
     * 
     * @return string an xml export of $this.  The string must be freed by the
     *      caller.
     */
    public function exportToXml() {
        return lasso_node_export_to_xml($this->_cptr);
    }

    /**
     * Exports $this to a PAOS message.
     * 
     * @return string a PAOS export of $this.  The string must be freed by the
     *      caller.
     */
    public function exportToPaosRequest($issuer, $responseConsumerURL, $relay_state) {
        return lasso_node_export_to_paos_request($this->_cptr, $issuer, $responseConsumerURL, $relay_state);
    }

    /**
     * Exports $this to a ECP SOAP message.
     * 
     * @return string a ECP SOAP export of $this.  The string must be freed by the
     *      caller.
     */
    public function exportToEcpSoapResponse($assertionConsumerURL) {
        return lasso_node_export_to_ecp_soap_response($this->_cptr, $assertionConsumerURL);
    }

    /**
     * Builds an XML representation of $this.
     * 
     * @return string a new xmlNode.  It must be freed by the caller.
     */
    public function getXmlNode($lasso_dump) {
        return lasso_node_get_xmlNode($this->_cptr, $lasso_dump);
    }

    /**
     * Parses $message and initialiazes $this fields with data from it.  Message
     * type may be base64, SOAP, XML or query string, correct type is found
     * automatically.
     * 
     * @return int message format
     */
    public function initFromMessage($message) {
        return lasso_node_init_from_message($this->_cptr, $message);
    }

    /**
     * Initialiazes $this fields with data from $query string.
     * 
     * @return boolean TRUE if success
     */
    public function initFromQuery($query) {
        return lasso_node_init_from_query($this->_cptr, $query);
    }

    /**
     * Initialiazes $this fields with data from $xmlnode XML node.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function initFromXml($xmlnode) {
        $rc = lasso_node_init_from_xml($this->_cptr, $xmlnode._cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoNodeNoInit extends LassoNode {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoDsKeyInfo extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_ds_key_info_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoDsKeyInfo  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoDsKeyValue
     */
    protected function get_keyValue() {
        return cptrToPhp(LassoDsKeyInfo_keyValue_get($this->_cptr));
    }
    protected function set_keyValue($value) {
        LassoDsKeyInfo_keyValue_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoDsKeyInfoNoInit extends LassoDsKeyInfo {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoDsKeyValue extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_ds_key_value_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoDsKeyValue  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoDsRsaKeyValue
     */
    protected function get_rSAKeyValue() {
        return cptrToPhp(LassoDsKeyValue_rSAKeyValue_get($this->_cptr));
    }
    protected function set_rSAKeyValue($value) {
        LassoDsKeyValue_rSAKeyValue_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoDsKeyValueNoInit extends LassoDsKeyValue {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoDsRsaKeyValue extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_ds_rsa_key_value_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoDsRsaKeyValue  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_modulus() {
        return LassoDsRsaKeyValue_modulus_get($this->_cptr);
    }
    protected function set_modulus($value) {
        LassoDsRsaKeyValue_modulus_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_exponent() {
        return LassoDsRsaKeyValue_exponent_get($this->_cptr);
    }
    protected function set_exponent($value) {
        LassoDsRsaKeyValue_exponent_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoDsRsaKeyValueNoInit extends LassoDsRsaKeyValue {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAuthnContext extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_authn_context_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAuthnContext  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_authnContextClassRef() {
        return LassoLibAuthnContext_authnContextClassRef_get($this->_cptr);
    }
    protected function set_authnContextClassRef($value) {
        LassoLibAuthnContext_authnContextClassRef_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_authnContextStatementRef() {
        return LassoLibAuthnContext_authnContextStatementRef_get($this->_cptr);
    }
    protected function set_authnContextStatementRef($value) {
        LassoLibAuthnContext_authnContextStatementRef_set($this->_cptr, $value);
    }

    /**
     * @return void
     */
    protected function get_authenticationContextStatement() {
        return cptrToPhp(LassoLibAuthnContext_authenticationContextStatement_get($this->_cptr));
    }
    protected function set_authenticationContextStatement($value) {
        LassoLibAuthnContext_authenticationContextStatement_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoLibAuthnContextNoInit extends LassoLibAuthnContext {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAuthnRequestEnvelope extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_authn_request_envelope_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAuthnRequestEnvelope  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_extension() {
        $array = LassoLibAuthnRequestEnvelope_extension_get($this->_cptr);
        return $array;
    }
    protected function set_extension($value) {
        LassoLibAuthnRequestEnvelope_extension_set($this->_cptr, $value);
    }

    /**
     * @return LassoLibAuthnRequest
     */
    protected function get_authnRequest() {
        return cptrToPhp(LassoLibAuthnRequestEnvelope_authnRequest_get($this->_cptr));
    }
    protected function set_authnRequest($value) {
        LassoLibAuthnRequestEnvelope_authnRequest_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_providerId() {
        return LassoLibAuthnRequestEnvelope_providerId_get($this->_cptr);
    }
    protected function set_providerId($value) {
        LassoLibAuthnRequestEnvelope_providerId_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_providerName() {
        return LassoLibAuthnRequestEnvelope_providerName_get($this->_cptr);
    }
    protected function set_providerName($value) {
        LassoLibAuthnRequestEnvelope_providerName_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_assertionConsumerServiceURL() {
        return LassoLibAuthnRequestEnvelope_assertionConsumerServiceURL_get($this->_cptr);
    }
    protected function set_assertionConsumerServiceURL($value) {
        LassoLibAuthnRequestEnvelope_assertionConsumerServiceURL_set($this->_cptr, $value);
    }

    /**
     * @return LassoLibIDPList
     */
    protected function get_iDPList() {
        return cptrToPhp(LassoLibAuthnRequestEnvelope_iDPList_get($this->_cptr));
    }
    protected function set_iDPList($value) {
        LassoLibAuthnRequestEnvelope_iDPList_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return boolean
     */
    protected function get_isPassive() {
        return LassoLibAuthnRequestEnvelope_isPassive_get($this->_cptr);
    }
    protected function set_isPassive($value) {
        LassoLibAuthnRequestEnvelope_isPassive_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAuthnRequestEnvelopeNoInit extends LassoLibAuthnRequestEnvelope {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAuthnResponseEnvelope extends LassoNode {
    public $_cptr = null;

    public function __construct($response, $assertionConsumerServiceURL) {
        $this->_cptr = lasso_lib_authn_response_envelope_new($response->_cptr, $assertionConsumerServiceURL);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAuthnResponseEnvelope  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_extension() {
        $array = LassoLibAuthnResponseEnvelope_extension_get($this->_cptr);
        return $array;
    }
    protected function set_extension($value) {
        LassoLibAuthnResponseEnvelope_extension_set($this->_cptr, $value);
    }

    /**
     * @return LassoLibAuthnResponse
     */
    protected function get_authnResponse() {
        return cptrToPhp(LassoLibAuthnResponseEnvelope_authnResponse_get($this->_cptr));
    }
    protected function set_authnResponse($value) {
        LassoLibAuthnResponseEnvelope_authnResponse_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_assertionConsumerServiceURL() {
        return LassoLibAuthnResponseEnvelope_assertionConsumerServiceURL_get($this->_cptr);
    }
    protected function set_assertionConsumerServiceURL($value) {
        LassoLibAuthnResponseEnvelope_assertionConsumerServiceURL_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAuthnResponseEnvelopeNoInit extends LassoLibAuthnResponseEnvelope {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibIDPEntries extends LassoNode {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_iDPEntry() {
        $array = LassoLibIDPEntries_iDPEntry_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_iDPEntry($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoLibIDPEntries_iDPEntry_set($this->_cptr, $array);
    }


}

/**
 * @package Lasso
 */
class LassoLibIDPEntriesNoInit extends LassoLibIDPEntries {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibIDPEntry extends LassoNode {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_providerId() {
        return LassoLibIDPEntry_providerId_get($this->_cptr);
    }
    protected function set_providerId($value) {
        LassoLibIDPEntry_providerId_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_providerName() {
        return LassoLibIDPEntry_providerName_get($this->_cptr);
    }
    protected function set_providerName($value) {
        LassoLibIDPEntry_providerName_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_loc() {
        return LassoLibIDPEntry_loc_get($this->_cptr);
    }
    protected function set_loc($value) {
        LassoLibIDPEntry_loc_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibIDPEntryNoInit extends LassoLibIDPEntry {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibIDPList extends LassoNode {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoLibIDPEntries
     */
    protected function get_iDPEntries() {
        return cptrToPhp(LassoLibIDPList_iDPEntries_get($this->_cptr));
    }
    protected function set_iDPEntries($value) {
        LassoLibIDPList_iDPEntries_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_getComplete() {
        return LassoLibIDPList_getComplete_get($this->_cptr);
    }
    protected function set_getComplete($value) {
        LassoLibIDPList_getComplete_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibIDPListNoInit extends LassoLibIDPList {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibRequestAuthnContext extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_request_authn_context_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibRequestAuthnContext  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_authnContextClassRef() {
        $array = LassoLibRequestAuthnContext_authnContextClassRef_get($this->_cptr);
        return $array;
    }
    protected function set_authnContextClassRef($value) {
        LassoLibRequestAuthnContext_authnContextClassRef_set($this->_cptr, $value);
    }

    /**
     * @return array
     */
    protected function get_authnContextStatementRef() {
        $array = LassoLibRequestAuthnContext_authnContextStatementRef_get($this->_cptr);
        return $array;
    }
    protected function set_authnContextStatementRef($value) {
        LassoLibRequestAuthnContext_authnContextStatementRef_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_authnContextComparison() {
        return LassoLibRequestAuthnContext_authnContextComparison_get($this->_cptr);
    }
    protected function set_authnContextComparison($value) {
        LassoLibRequestAuthnContext_authnContextComparison_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibRequestAuthnContextNoInit extends LassoLibRequestAuthnContext {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibScoping extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_scoping_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibScoping  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return int
     */
    protected function get_proxyCount() {
        return LassoLibScoping_proxyCount_get($this->_cptr);
    }
    protected function set_proxyCount($value) {
        LassoLibScoping_proxyCount_set($this->_cptr, $value);
    }

    /**
     * @return LassoLibIDPList
     */
    protected function get_iDPList() {
        return cptrToPhp(LassoLibScoping_iDPList_get($this->_cptr));
    }
    protected function set_iDPList($value) {
        LassoLibScoping_iDPList_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoLibScopingNoInit extends LassoLibScoping {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoMiscTextNode extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_misc_text_node_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoMiscTextNode  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_content() {
        return LassoMiscTextNode_content_get($this->_cptr);
    }
    protected function set_content($value) {
        LassoMiscTextNode_content_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_name() {
        return LassoMiscTextNode_name_get($this->_cptr);
    }
    protected function set_name($value) {
        LassoMiscTextNode_name_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_nsHref() {
        return LassoMiscTextNode_nsHref_get($this->_cptr);
    }
    protected function set_nsHref($value) {
        LassoMiscTextNode_nsHref_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_nsPrefix() {
        return LassoMiscTextNode_nsPrefix_get($this->_cptr);
    }
    protected function set_nsPrefix($value) {
        LassoMiscTextNode_nsPrefix_set($this->_cptr, $value);
    }

    /**
     * @return boolean
     */
    protected function get_textChild() {
        return LassoMiscTextNode_textChild_get($this->_cptr);
    }
    protected function set_textChild($value) {
        LassoMiscTextNode_textChild_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoMiscTextNodeNoInit extends LassoMiscTextNode {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAdvice extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_advice_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAdvice  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_assertionIdReference() {
        $array = LassoSamlAdvice_assertionIdReference_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_assertionIdReference($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlAdvice_assertionIdReference_set($this->_cptr, $array);
    }

    /**
     * @return LassoNode
     */
    protected function get_assertion() {
        return cptrToPhp(LassoSamlAdvice_assertion_get($this->_cptr));
    }
    protected function set_assertion($value) {
        LassoSamlAdvice_assertion_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAdviceNoInit extends LassoSamlAdvice {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAssertion extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_assertion_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAssertion  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlConditions
     */
    protected function get_conditions() {
        return cptrToPhp(LassoSamlAssertion_conditions_get($this->_cptr));
    }
    protected function set_conditions($value) {
        LassoSamlAssertion_conditions_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlAdvice
     */
    protected function get_advice() {
        return cptrToPhp(LassoSamlAssertion_advice_get($this->_cptr));
    }
    protected function set_advice($value) {
        LassoSamlAssertion_advice_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return void
     */
    protected function get_statement() {
        return cptrToPhp(LassoSamlAssertion_statement_get($this->_cptr));
    }
    protected function set_statement($value) {
        LassoSamlAssertion_statement_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlSubjectStatement
     */
    protected function get_subjectStatement() {
        return cptrToPhp(LassoSamlAssertion_subjectStatement_get($this->_cptr));
    }
    protected function set_subjectStatement($value) {
        LassoSamlAssertion_subjectStatement_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlAuthenticationStatement
     */
    protected function get_authenticationStatement() {
        return cptrToPhp(LassoSamlAssertion_authenticationStatement_get($this->_cptr));
    }
    protected function set_authenticationStatement($value) {
        LassoSamlAssertion_authenticationStatement_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return void
     */
    protected function get_authorizationDecisionStatement() {
        return cptrToPhp(LassoSamlAssertion_authorizationDecisionStatement_get($this->_cptr));
    }
    protected function set_authorizationDecisionStatement($value) {
        LassoSamlAssertion_authorizationDecisionStatement_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlAttributeStatement
     */
    protected function get_attributeStatement() {
        return cptrToPhp(LassoSamlAssertion_attributeStatement_get($this->_cptr));
    }
    protected function set_attributeStatement($value) {
        LassoSamlAssertion_attributeStatement_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return int
     */
    protected function get_majorVersion() {
        return LassoSamlAssertion_majorVersion_get($this->_cptr);
    }
    protected function set_majorVersion($value) {
        LassoSamlAssertion_majorVersion_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_minorVersion() {
        return LassoSamlAssertion_minorVersion_get($this->_cptr);
    }
    protected function set_minorVersion($value) {
        LassoSamlAssertion_minorVersion_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_assertionId() {
        return LassoSamlAssertion_assertionId_get($this->_cptr);
    }
    protected function set_assertionId($value) {
        LassoSamlAssertion_assertionId_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_issuer() {
        return LassoSamlAssertion_issuer_get($this->_cptr);
    }
    protected function set_issuer($value) {
        LassoSamlAssertion_issuer_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_issueInstant() {
        return LassoSamlAssertion_issueInstant_get($this->_cptr);
    }
    protected function set_issueInstant($value) {
        LassoSamlAssertion_issueInstant_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_signType() {
        return LassoSamlAssertion_signType_get($this->_cptr);
    }
    protected function set_signType($value) {
        LassoSamlAssertion_signType_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_signMethod() {
        return LassoSamlAssertion_signMethod_get($this->_cptr);
    }
    protected function set_signMethod($value) {
        LassoSamlAssertion_signMethod_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_privateKeyFile() {
        return LassoSamlAssertion_privateKeyFile_get($this->_cptr);
    }
    protected function set_privateKeyFile($value) {
        LassoSamlAssertion_privateKeyFile_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_certificateFile() {
        return LassoSamlAssertion_certificateFile_get($this->_cptr);
    }
    protected function set_certificateFile($value) {
        LassoSamlAssertion_certificateFile_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAssertionNoInit extends LassoSamlAssertion {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAssertion extends LassoSamlAssertion {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_assertion_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAssertion  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_inResponseTo() {
        return LassoLibAssertion_inResponseTo_get($this->_cptr);
    }
    protected function set_inResponseTo($value) {
        LassoLibAssertion_inResponseTo_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAssertionNoInit extends LassoLibAssertion {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAttributeDesignator extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_attribute_designator_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAttributeDesignator  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_attributeName() {
        return LassoSamlAttributeDesignator_attributeName_get($this->_cptr);
    }
    protected function set_attributeName($value) {
        LassoSamlAttributeDesignator_attributeName_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_attributeNamespace() {
        return LassoSamlAttributeDesignator_attributeNamespace_get($this->_cptr);
    }
    protected function set_attributeNamespace($value) {
        LassoSamlAttributeDesignator_attributeNamespace_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAttributeDesignatorNoInit extends LassoSamlAttributeDesignator {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAttribute extends LassoSamlAttributeDesignator {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_attribute_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAttribute  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_attributeName() {
        return LassoSamlAttribute_attributeName_get($this->_cptr);
    }
    protected function set_attributeName($value) {
        LassoSamlAttribute_attributeName_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_attributeNameSpace() {
        return LassoSamlAttribute_attributeNameSpace_get($this->_cptr);
    }
    protected function set_attributeNameSpace($value) {
        LassoSamlAttribute_attributeNameSpace_set($this->_cptr, $value);
    }

    /**
     * @return array
     */
    protected function get_attributeValue() {
        $array = LassoSamlAttribute_attributeValue_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_attributeValue($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlAttribute_attributeValue_set($this->_cptr, $array);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAttributeNoInit extends LassoSamlAttribute {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAttributeValue extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_attribute_value_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAttributeValue  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_any() {
        $array = LassoSamlAttributeValue_any_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_any($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlAttributeValue_any_set($this->_cptr, $array);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAttributeValueNoInit extends LassoSamlAttributeValue {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAuthorityBinding extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_authority_binding_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAuthorityBinding  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_authorityKind() {
        return LassoSamlAuthorityBinding_authorityKind_get($this->_cptr);
    }
    protected function set_authorityKind($value) {
        LassoSamlAuthorityBinding_authorityKind_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_location() {
        return LassoSamlAuthorityBinding_location_get($this->_cptr);
    }
    protected function set_location($value) {
        LassoSamlAuthorityBinding_location_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_binding() {
        return LassoSamlAuthorityBinding_binding_get($this->_cptr);
    }
    protected function set_binding($value) {
        LassoSamlAuthorityBinding_binding_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAuthorityBindingNoInit extends LassoSamlAuthorityBinding {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlConditionAbstract extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSamlConditionAbstractNoInit extends LassoSamlConditionAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAudienceRestrictionCondition extends LassoSamlConditionAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_audience_restriction_condition_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAudienceRestrictionCondition  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_audience() {
        $array = LassoSamlAudienceRestrictionCondition_audience_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_audience($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlAudienceRestrictionCondition_audience_set($this->_cptr, $array);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAudienceRestrictionConditionNoInit extends LassoSamlAudienceRestrictionCondition {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlConditions extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_conditions_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlConditions  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_condition() {
        $array = LassoSamlConditions_condition_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_condition($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlConditions_condition_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_audienceRestrictionCondition() {
        $array = LassoSamlConditions_audienceRestrictionCondition_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_audienceRestrictionCondition($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlConditions_audienceRestrictionCondition_set($this->_cptr, $array);
    }

    /**
     * @return string
     */
    protected function get_notBefore() {
        return LassoSamlConditions_notBefore_get($this->_cptr);
    }
    protected function set_notBefore($value) {
        LassoSamlConditions_notBefore_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_notOnOrAfter() {
        return LassoSamlConditions_notOnOrAfter_get($this->_cptr);
    }
    protected function set_notOnOrAfter($value) {
        LassoSamlConditions_notOnOrAfter_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlConditionsNoInit extends LassoSamlConditions {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlNameIdentifier extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_name_identifier_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlNameIdentifier  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_nameQualifier() {
        return LassoSamlNameIdentifier_nameQualifier_get($this->_cptr);
    }
    protected function set_nameQualifier($value) {
        LassoSamlNameIdentifier_nameQualifier_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_format() {
        return LassoSamlNameIdentifier_format_get($this->_cptr);
    }
    protected function set_format($value) {
        LassoSamlNameIdentifier_format_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_content() {
        return LassoSamlNameIdentifier_content_get($this->_cptr);
    }
    protected function set_content($value) {
        LassoSamlNameIdentifier_content_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlNameIdentifierNoInit extends LassoSamlNameIdentifier {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlStatementAbstract extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSamlStatementAbstractNoInit extends LassoSamlStatementAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlSubject extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_subject_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlSubject  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlNameIdentifier
     */
    protected function get_nameIdentifier() {
        return cptrToPhp(LassoSamlSubject_nameIdentifier_get($this->_cptr));
    }
    protected function set_nameIdentifier($value) {
        LassoSamlSubject_nameIdentifier_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlSubjectConfirmation
     */
    protected function get_subjectConfirmation() {
        return cptrToPhp(LassoSamlSubject_subjectConfirmation_get($this->_cptr));
    }
    protected function set_subjectConfirmation($value) {
        LassoSamlSubject_subjectConfirmation_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2EncryptedElement
     */
    protected function get_encryptedNameIdentifier() {
        return cptrToPhp(LassoSamlSubject_encryptedNameIdentifier_get($this->_cptr));
    }
    protected function set_encryptedNameIdentifier($value) {
        LassoSamlSubject_encryptedNameIdentifier_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSamlSubjectNoInit extends LassoSamlSubject {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibSubject extends LassoSamlSubject {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_subject_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibSubject  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlNameIdentifier
     */
    protected function get_iDPProvidedNameIdentifier() {
        return cptrToPhp(LassoLibSubject_iDPProvidedNameIdentifier_get($this->_cptr));
    }
    protected function set_iDPProvidedNameIdentifier($value) {
        LassoLibSubject_iDPProvidedNameIdentifier_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoLibSubjectNoInit extends LassoLibSubject {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlSubjectConfirmation extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_subject_confirmation_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlSubjectConfirmation  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_confirmationMethod() {
        $array = LassoSamlSubjectConfirmation_confirmationMethod_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_confirmationMethod($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlSubjectConfirmation_confirmationMethod_set($this->_cptr, $array);
    }

    /**
     * @return string
     */
    protected function get_subjectConfirmationData() {
        return LassoSamlSubjectConfirmation_subjectConfirmationData_get($this->_cptr);
    }
    protected function set_subjectConfirmationData($value) {
        LassoSamlSubjectConfirmation_subjectConfirmationData_set($this->_cptr, $value);
    }

    /**
     * @return LassoDsKeyInfo
     */
    protected function get_keyInfo() {
        return cptrToPhp(LassoSamlSubjectConfirmation_keyInfo_get($this->_cptr));
    }
    protected function set_keyInfo($value) {
        LassoSamlSubjectConfirmation_keyInfo_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSamlSubjectConfirmationNoInit extends LassoSamlSubjectConfirmation {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlSubjectLocality extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_subject_locality_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlSubjectLocality  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_iPAddress() {
        return LassoSamlSubjectLocality_iPAddress_get($this->_cptr);
    }
    protected function set_iPAddress($value) {
        LassoSamlSubjectLocality_iPAddress_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_dNSAddress() {
        return LassoSamlSubjectLocality_dNSAddress_get($this->_cptr);
    }
    protected function set_dNSAddress($value) {
        LassoSamlSubjectLocality_dNSAddress_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlSubjectLocalityNoInit extends LassoSamlSubjectLocality {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlSubjectStatementAbstract extends LassoSamlStatementAbstract {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlSubject
     */
    protected function get_subject() {
        return cptrToPhp(LassoSamlSubjectStatementAbstract_subject_get($this->_cptr));
    }
    protected function set_subject($value) {
        LassoSamlSubjectStatementAbstract_subject_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSamlSubjectStatementAbstractNoInit extends LassoSamlSubjectStatementAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAttributeStatement extends LassoSamlSubjectStatementAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_attribute_statement_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAttributeStatement  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_attribute() {
        $array = LassoSamlAttributeStatement_attribute_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_attribute($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlAttributeStatement_attribute_set($this->_cptr, $array);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAttributeStatementNoInit extends LassoSamlAttributeStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlAuthenticationStatement extends LassoSamlSubjectStatementAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml_authentication_statement_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlAuthenticationStatement  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlSubjectLocality
     */
    protected function get_subjectLocality() {
        return cptrToPhp(LassoSamlAuthenticationStatement_subjectLocality_get($this->_cptr));
    }
    protected function set_subjectLocality($value) {
        LassoSamlAuthenticationStatement_subjectLocality_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return array
     */
    protected function get_authorityBinding() {
        $array = LassoSamlAuthenticationStatement_authorityBinding_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_authorityBinding($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlAuthenticationStatement_authorityBinding_set($this->_cptr, $array);
    }

    /**
     * @return string
     */
    protected function get_authenticationMethod() {
        return LassoSamlAuthenticationStatement_authenticationMethod_get($this->_cptr);
    }
    protected function set_authenticationMethod($value) {
        LassoSamlAuthenticationStatement_authenticationMethod_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_authenticationInstant() {
        return LassoSamlAuthenticationStatement_authenticationInstant_get($this->_cptr);
    }
    protected function set_authenticationInstant($value) {
        LassoSamlAuthenticationStatement_authenticationInstant_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlAuthenticationStatementNoInit extends LassoSamlAuthenticationStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAuthenticationStatement extends LassoSamlAuthenticationStatement {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_authentication_statement_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAuthenticationStatement  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoLibAuthnContext
     */
    protected function get_authnContext() {
        return cptrToPhp(LassoLibAuthenticationStatement_authnContext_get($this->_cptr));
    }
    protected function set_authnContext($value) {
        LassoLibAuthenticationStatement_authnContext_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_reauthenticateOnOrAfter() {
        return LassoLibAuthenticationStatement_reauthenticateOnOrAfter_get($this->_cptr);
    }
    protected function set_reauthenticateOnOrAfter($value) {
        LassoLibAuthenticationStatement_reauthenticateOnOrAfter_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_sessionIndex() {
        return LassoLibAuthenticationStatement_sessionIndex_get($this->_cptr);
    }
    protected function set_sessionIndex($value) {
        LassoLibAuthenticationStatement_sessionIndex_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAuthenticationStatementNoInit extends LassoLibAuthenticationStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlSubjectStatement extends LassoSamlSubjectStatementAbstract {
}

/**
 * @package Lasso
 */
class LassoSamlSubjectStatementNoInit extends LassoSamlSubjectStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlpRequestAbstract extends LassoNode {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_respondWith() {
        $array = LassoSamlpRequestAbstract_respondWith_get($this->_cptr);
        return $array;
    }
    protected function set_respondWith($value) {
        LassoSamlpRequestAbstract_respondWith_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_requestId() {
        return LassoSamlpRequestAbstract_requestId_get($this->_cptr);
    }
    protected function set_requestId($value) {
        LassoSamlpRequestAbstract_requestId_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_majorVersion() {
        return LassoSamlpRequestAbstract_majorVersion_get($this->_cptr);
    }
    protected function set_majorVersion($value) {
        LassoSamlpRequestAbstract_majorVersion_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_minorVersion() {
        return LassoSamlpRequestAbstract_minorVersion_get($this->_cptr);
    }
    protected function set_minorVersion($value) {
        LassoSamlpRequestAbstract_minorVersion_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_issueInstant() {
        return LassoSamlpRequestAbstract_issueInstant_get($this->_cptr);
    }
    protected function set_issueInstant($value) {
        LassoSamlpRequestAbstract_issueInstant_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_signType() {
        return LassoSamlpRequestAbstract_signType_get($this->_cptr);
    }
    protected function set_signType($value) {
        LassoSamlpRequestAbstract_signType_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_signMethod() {
        return LassoSamlpRequestAbstract_signMethod_get($this->_cptr);
    }
    protected function set_signMethod($value) {
        LassoSamlpRequestAbstract_signMethod_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_privateKeyFile() {
        return LassoSamlpRequestAbstract_privateKeyFile_get($this->_cptr);
    }
    protected function set_privateKeyFile($value) {
        LassoSamlpRequestAbstract_privateKeyFile_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_certificateFile() {
        return LassoSamlpRequestAbstract_certificateFile_get($this->_cptr);
    }
    protected function set_certificateFile($value) {
        LassoSamlpRequestAbstract_certificateFile_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlpRequestAbstractNoInit extends LassoSamlpRequestAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAuthnRequest extends LassoSamlpRequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_authn_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAuthnRequest  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_extension() {
        $array = LassoLibAuthnRequest_extension_get($this->_cptr);
        return $array;
    }
    protected function set_extension($value) {
        LassoLibAuthnRequest_extension_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_providerId() {
        return LassoLibAuthnRequest_providerId_get($this->_cptr);
    }
    protected function set_providerId($value) {
        LassoLibAuthnRequest_providerId_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_affiliationId() {
        return LassoLibAuthnRequest_affiliationId_get($this->_cptr);
    }
    protected function set_affiliationId($value) {
        LassoLibAuthnRequest_affiliationId_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_nameIdPolicy() {
        return LassoLibAuthnRequest_nameIdPolicy_get($this->_cptr);
    }
    protected function set_nameIdPolicy($value) {
        LassoLibAuthnRequest_nameIdPolicy_set($this->_cptr, $value);
    }

    /**
     * @return boolean
     */
    protected function get_forceAuthn() {
        return LassoLibAuthnRequest_forceAuthn_get($this->_cptr);
    }
    protected function set_forceAuthn($value) {
        LassoLibAuthnRequest_forceAuthn_set($this->_cptr, $value);
    }

    /**
     * @return boolean
     */
    protected function get_isPassive() {
        return LassoLibAuthnRequest_isPassive_get($this->_cptr);
    }
    protected function set_isPassive($value) {
        LassoLibAuthnRequest_isPassive_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_protocolProfile() {
        return LassoLibAuthnRequest_protocolProfile_get($this->_cptr);
    }
    protected function set_protocolProfile($value) {
        LassoLibAuthnRequest_protocolProfile_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_assertionConsumerServiceId() {
        return LassoLibAuthnRequest_assertionConsumerServiceId_get($this->_cptr);
    }
    protected function set_assertionConsumerServiceId($value) {
        LassoLibAuthnRequest_assertionConsumerServiceId_set($this->_cptr, $value);
    }

    /**
     * @return LassoLibRequestAuthnContext
     */
    protected function get_requestAuthnContext() {
        return cptrToPhp(LassoLibAuthnRequest_requestAuthnContext_get($this->_cptr));
    }
    protected function set_requestAuthnContext($value) {
        LassoLibAuthnRequest_requestAuthnContext_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_relayState() {
        return LassoLibAuthnRequest_relayState_get($this->_cptr);
    }
    protected function set_relayState($value) {
        LassoLibAuthnRequest_relayState_set($this->_cptr, $value);
    }

    /**
     * @return LassoLibScoping
     */
    protected function get_scoping() {
        return cptrToPhp(LassoLibAuthnRequest_scoping_get($this->_cptr));
    }
    protected function set_scoping($value) {
        LassoLibAuthnRequest_scoping_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_consent() {
        return LassoLibAuthnRequest_consent_get($this->_cptr);
    }
    protected function set_consent($value) {
        LassoLibAuthnRequest_consent_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAuthnRequestNoInit extends LassoLibAuthnRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibFederationTerminationNotification extends LassoSamlpRequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_federation_termination_notification_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibFederationTerminationNotification  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_extension() {
        $array = LassoLibFederationTerminationNotification_extension_get($this->_cptr);
        return $array;
    }
    protected function set_extension($value) {
        LassoLibFederationTerminationNotification_extension_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_providerId() {
        return LassoLibFederationTerminationNotification_providerId_get($this->_cptr);
    }
    protected function set_providerId($value) {
        LassoLibFederationTerminationNotification_providerId_set($this->_cptr, $value);
    }

    /**
     * @return LassoSamlNameIdentifier
     */
    protected function get_nameIdentifier() {
        return cptrToPhp(LassoLibFederationTerminationNotification_nameIdentifier_get($this->_cptr));
    }
    protected function set_nameIdentifier($value) {
        LassoLibFederationTerminationNotification_nameIdentifier_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_consent() {
        return LassoLibFederationTerminationNotification_consent_get($this->_cptr);
    }
    protected function set_consent($value) {
        LassoLibFederationTerminationNotification_consent_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_relayState() {
        return LassoLibFederationTerminationNotification_relayState_get($this->_cptr);
    }
    protected function set_relayState($value) {
        LassoLibFederationTerminationNotification_relayState_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibFederationTerminationNotificationNoInit extends LassoLibFederationTerminationNotification {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibLogoutRequest extends LassoSamlpRequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_logout_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibLogoutRequest  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_extension() {
        $array = LassoLibLogoutRequest_extension_get($this->_cptr);
        return $array;
    }
    protected function set_extension($value) {
        LassoLibLogoutRequest_extension_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_providerId() {
        return LassoLibLogoutRequest_providerId_get($this->_cptr);
    }
    protected function set_providerId($value) {
        LassoLibLogoutRequest_providerId_set($this->_cptr, $value);
    }

    /**
     * @return LassoSamlNameIdentifier
     */
    protected function get_nameIdentifier() {
        return cptrToPhp(LassoLibLogoutRequest_nameIdentifier_get($this->_cptr));
    }
    protected function set_nameIdentifier($value) {
        LassoLibLogoutRequest_nameIdentifier_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_sessionIndex() {
        return LassoLibLogoutRequest_sessionIndex_get($this->_cptr);
    }
    protected function set_sessionIndex($value) {
        LassoLibLogoutRequest_sessionIndex_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_relayState() {
        return LassoLibLogoutRequest_relayState_get($this->_cptr);
    }
    protected function set_relayState($value) {
        LassoLibLogoutRequest_relayState_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_consent() {
        return LassoLibLogoutRequest_consent_get($this->_cptr);
    }
    protected function set_consent($value) {
        LassoLibLogoutRequest_consent_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_notOnOrAfter() {
        return LassoLibLogoutRequest_notOnOrAfter_get($this->_cptr);
    }
    protected function set_notOnOrAfter($value) {
        LassoLibLogoutRequest_notOnOrAfter_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibLogoutRequestNoInit extends LassoLibLogoutRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibNameIdentifierMappingRequest extends LassoSamlpRequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_name_identifier_mapping_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibNameIdentifierMappingRequest  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_extension() {
        $array = LassoLibNameIdentifierMappingRequest_extension_get($this->_cptr);
        return $array;
    }
    protected function set_extension($value) {
        LassoLibNameIdentifierMappingRequest_extension_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_providerId() {
        return LassoLibNameIdentifierMappingRequest_providerId_get($this->_cptr);
    }
    protected function set_providerId($value) {
        LassoLibNameIdentifierMappingRequest_providerId_set($this->_cptr, $value);
    }

    /**
     * @return LassoSamlNameIdentifier
     */
    protected function get_nameIdentifier() {
        return cptrToPhp(LassoLibNameIdentifierMappingRequest_nameIdentifier_get($this->_cptr));
    }
    protected function set_nameIdentifier($value) {
        LassoLibNameIdentifierMappingRequest_nameIdentifier_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_targetNamespace() {
        return LassoLibNameIdentifierMappingRequest_targetNamespace_get($this->_cptr);
    }
    protected function set_targetNamespace($value) {
        LassoLibNameIdentifierMappingRequest_targetNamespace_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_consent() {
        return LassoLibNameIdentifierMappingRequest_consent_get($this->_cptr);
    }
    protected function set_consent($value) {
        LassoLibNameIdentifierMappingRequest_consent_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibNameIdentifierMappingRequestNoInit extends LassoLibNameIdentifierMappingRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibRegisterNameIdentifierRequest extends LassoSamlpRequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_register_name_identifier_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibRegisterNameIdentifierRequest  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_extension() {
        $array = LassoLibRegisterNameIdentifierRequest_extension_get($this->_cptr);
        return $array;
    }
    protected function set_extension($value) {
        LassoLibRegisterNameIdentifierRequest_extension_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_providerId() {
        return LassoLibRegisterNameIdentifierRequest_providerId_get($this->_cptr);
    }
    protected function set_providerId($value) {
        LassoLibRegisterNameIdentifierRequest_providerId_set($this->_cptr, $value);
    }

    /**
     * @return LassoSamlNameIdentifier
     */
    protected function get_iDPProvidedNameIdentifier() {
        return cptrToPhp(LassoLibRegisterNameIdentifierRequest_iDPProvidedNameIdentifier_get($this->_cptr));
    }
    protected function set_iDPProvidedNameIdentifier($value) {
        LassoLibRegisterNameIdentifierRequest_iDPProvidedNameIdentifier_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlNameIdentifier
     */
    protected function get_sPProvidedNameIdentifier() {
        return cptrToPhp(LassoLibRegisterNameIdentifierRequest_sPProvidedNameIdentifier_get($this->_cptr));
    }
    protected function set_sPProvidedNameIdentifier($value) {
        LassoLibRegisterNameIdentifierRequest_sPProvidedNameIdentifier_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlNameIdentifier
     */
    protected function get_oldProvidedNameIdentifier() {
        return cptrToPhp(LassoLibRegisterNameIdentifierRequest_oldProvidedNameIdentifier_get($this->_cptr));
    }
    protected function set_oldProvidedNameIdentifier($value) {
        LassoLibRegisterNameIdentifierRequest_oldProvidedNameIdentifier_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_relayState() {
        return LassoLibRegisterNameIdentifierRequest_relayState_get($this->_cptr);
    }
    protected function set_relayState($value) {
        LassoLibRegisterNameIdentifierRequest_relayState_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibRegisterNameIdentifierRequestNoInit extends LassoLibRegisterNameIdentifierRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlpRequest extends LassoSamlpRequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlpRequest  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_assertionArtifact() {
        return LassoSamlpRequest_assertionArtifact_get($this->_cptr);
    }
    protected function set_assertionArtifact($value) {
        LassoSamlpRequest_assertionArtifact_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlpRequestNoInit extends LassoSamlpRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlpResponseAbstract extends LassoNode {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_responseId() {
        return LassoSamlpResponseAbstract_responseId_get($this->_cptr);
    }
    protected function set_responseId($value) {
        LassoSamlpResponseAbstract_responseId_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_inResponseTo() {
        return LassoSamlpResponseAbstract_inResponseTo_get($this->_cptr);
    }
    protected function set_inResponseTo($value) {
        LassoSamlpResponseAbstract_inResponseTo_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_majorVersion() {
        return LassoSamlpResponseAbstract_majorVersion_get($this->_cptr);
    }
    protected function set_majorVersion($value) {
        LassoSamlpResponseAbstract_majorVersion_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_minorVersion() {
        return LassoSamlpResponseAbstract_minorVersion_get($this->_cptr);
    }
    protected function set_minorVersion($value) {
        LassoSamlpResponseAbstract_minorVersion_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_issueInstant() {
        return LassoSamlpResponseAbstract_issueInstant_get($this->_cptr);
    }
    protected function set_issueInstant($value) {
        LassoSamlpResponseAbstract_issueInstant_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_recipient() {
        return LassoSamlpResponseAbstract_recipient_get($this->_cptr);
    }
    protected function set_recipient($value) {
        LassoSamlpResponseAbstract_recipient_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_signType() {
        return LassoSamlpResponseAbstract_signType_get($this->_cptr);
    }
    protected function set_signType($value) {
        LassoSamlpResponseAbstract_signType_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_signMethod() {
        return LassoSamlpResponseAbstract_signMethod_get($this->_cptr);
    }
    protected function set_signMethod($value) {
        LassoSamlpResponseAbstract_signMethod_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_privateKeyFile() {
        return LassoSamlpResponseAbstract_privateKeyFile_get($this->_cptr);
    }
    protected function set_privateKeyFile($value) {
        LassoSamlpResponseAbstract_privateKeyFile_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_certificateFile() {
        return LassoSamlpResponseAbstract_certificateFile_get($this->_cptr);
    }
    protected function set_certificateFile($value) {
        LassoSamlpResponseAbstract_certificateFile_set($this->_cptr, $value);
    }

    public function fill($InResponseTo, $Recipient) {
        return lasso_samlp_response_abstract_fill($this->_cptr, $InResponseTo, $Recipient);
    }


}

/**
 * @package Lasso
 */
class LassoSamlpResponseAbstractNoInit extends LassoSamlpResponseAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibNameIdentifierMappingResponse extends LassoSamlpResponseAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_name_identifier_mapping_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibNameIdentifierMappingResponse  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_extension() {
        $array = LassoLibNameIdentifierMappingResponse_extension_get($this->_cptr);
        return $array;
    }
    protected function set_extension($value) {
        LassoLibNameIdentifierMappingResponse_extension_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_providerId() {
        return LassoLibNameIdentifierMappingResponse_providerId_get($this->_cptr);
    }
    protected function set_providerId($value) {
        LassoLibNameIdentifierMappingResponse_providerId_set($this->_cptr, $value);
    }

    /**
     * @return LassoSamlpStatus
     */
    protected function get_status() {
        return cptrToPhp(LassoLibNameIdentifierMappingResponse_status_get($this->_cptr));
    }
    protected function set_status($value) {
        LassoLibNameIdentifierMappingResponse_status_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlNameIdentifier
     */
    protected function get_nameIdentifier() {
        return cptrToPhp(LassoLibNameIdentifierMappingResponse_nameIdentifier_get($this->_cptr));
    }
    protected function set_nameIdentifier($value) {
        LassoLibNameIdentifierMappingResponse_nameIdentifier_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoLibNameIdentifierMappingResponseNoInit extends LassoLibNameIdentifierMappingResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibStatusResponse extends LassoSamlpResponseAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_lib_status_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibStatusResponse  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_extension() {
        $array = LassoLibStatusResponse_extension_get($this->_cptr);
        return $array;
    }
    protected function set_extension($value) {
        LassoLibStatusResponse_extension_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_providerId() {
        return LassoLibStatusResponse_providerId_get($this->_cptr);
    }
    protected function set_providerId($value) {
        LassoLibStatusResponse_providerId_set($this->_cptr, $value);
    }

    /**
     * @return LassoSamlpStatus
     */
    protected function get_status() {
        return cptrToPhp(LassoLibStatusResponse_status_get($this->_cptr));
    }
    protected function set_status($value) {
        LassoLibStatusResponse_status_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_relayState() {
        return LassoLibStatusResponse_relayState_get($this->_cptr);
    }
    protected function set_relayState($value) {
        LassoLibStatusResponse_relayState_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibStatusResponseNoInit extends LassoLibStatusResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibLogoutResponse extends LassoLibStatusResponse {
}

/**
 * @package Lasso
 */
class LassoLibLogoutResponseNoInit extends LassoLibLogoutResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibRegisterNameIdentifierResponse extends LassoLibStatusResponse {
}

/**
 * @package Lasso
 */
class LassoLibRegisterNameIdentifierResponseNoInit extends LassoLibRegisterNameIdentifierResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlpResponse extends LassoSamlpResponseAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlpResponse  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlpStatus
     */
    protected function get_status() {
        return cptrToPhp(LassoSamlpResponse_status_get($this->_cptr));
    }
    protected function set_status($value) {
        LassoSamlpResponse_status_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return array
     */
    protected function get_assertion() {
        $array = LassoSamlpResponse_assertion_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_assertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlpResponse_assertion_set($this->_cptr, $array);
    }


}

/**
 * @package Lasso
 */
class LassoSamlpResponseNoInit extends LassoSamlpResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLibAuthnResponse extends LassoSamlpResponse {
    public $_cptr = null;

    public function __construct($providerID, $request) {
        $this->_cptr = lasso_lib_authn_response_new($providerID, $request->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLibAuthnResponse  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_extension() {
        $array = LassoLibAuthnResponse_extension_get($this->_cptr);
        return $array;
    }
    protected function set_extension($value) {
        LassoLibAuthnResponse_extension_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_providerId() {
        return LassoLibAuthnResponse_providerId_get($this->_cptr);
    }
    protected function set_providerId($value) {
        LassoLibAuthnResponse_providerId_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_relayState() {
        return LassoLibAuthnResponse_relayState_get($this->_cptr);
    }
    protected function set_relayState($value) {
        LassoLibAuthnResponse_relayState_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_consent() {
        return LassoLibAuthnResponse_consent_get($this->_cptr);
    }
    protected function set_consent($value) {
        LassoLibAuthnResponse_consent_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoLibAuthnResponseNoInit extends LassoLibAuthnResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlpStatus extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp_status_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlpStatus  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlpStatusCode
     */
    protected function get_statusCode() {
        return cptrToPhp(LassoSamlpStatus_statusCode_get($this->_cptr));
    }
    protected function set_statusCode($value) {
        LassoSamlpStatus_statusCode_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_statusMessage() {
        return LassoSamlpStatus_statusMessage_get($this->_cptr);
    }
    protected function set_statusMessage($value) {
        LassoSamlpStatus_statusMessage_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlpStatusNoInit extends LassoSamlpStatus {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlpStatusCode extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp_status_code_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlpStatusCode  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlpStatusCode
     */
    protected function get_statusCode() {
        return cptrToPhp(LassoSamlpStatusCode_statusCode_get($this->_cptr));
    }
    protected function set_statusCode($value) {
        LassoSamlpStatusCode_statusCode_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_value() {
        return LassoSamlpStatusCode_value_get($this->_cptr);
    }
    protected function set_value($value) {
        LassoSamlpStatusCode_value_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlpStatusCodeNoInit extends LassoSamlpStatusCode {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Action extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_action_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Action  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_content() {
        return LassoSaml2Action_content_get($this->_cptr);
    }
    protected function set_content($value) {
        LassoSaml2Action_content_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_namespace() {
        return LassoSaml2Action_namespace_get($this->_cptr);
    }
    protected function set_namespace($value) {
        LassoSaml2Action_namespace_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2ActionNoInit extends LassoSaml2Action {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Advice extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_advice_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Advice  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_assertionIdRef() {
        $array = LassoSaml2Advice_assertionIdRef_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_assertionIdRef($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Advice_assertionIdRef_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_assertionURIRef() {
        $array = LassoSaml2Advice_assertionURIRef_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_assertionURIRef($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Advice_assertionURIRef_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_assertion() {
        $array = LassoSaml2Advice_assertion_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_assertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Advice_assertion_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_encryptedAssertion() {
        $array = LassoSaml2Advice_encryptedAssertion_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_encryptedAssertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Advice_encryptedAssertion_set($this->_cptr, $array);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AdviceNoInit extends LassoSaml2Advice {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Assertion extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_assertion_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Assertion  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2NameID
     */
    protected function get_issuer() {
        return cptrToPhp(LassoSaml2Assertion_issuer_get($this->_cptr));
    }
    protected function set_issuer($value) {
        LassoSaml2Assertion_issuer_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2Subject
     */
    protected function get_subject() {
        return cptrToPhp(LassoSaml2Assertion_subject_get($this->_cptr));
    }
    protected function set_subject($value) {
        LassoSaml2Assertion_subject_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2Conditions
     */
    protected function get_conditions() {
        return cptrToPhp(LassoSaml2Assertion_conditions_get($this->_cptr));
    }
    protected function set_conditions($value) {
        LassoSaml2Assertion_conditions_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2Advice
     */
    protected function get_advice() {
        return cptrToPhp(LassoSaml2Assertion_advice_get($this->_cptr));
    }
    protected function set_advice($value) {
        LassoSaml2Assertion_advice_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return array
     */
    protected function get_statement() {
        $array = LassoSaml2Assertion_statement_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_statement($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Assertion_statement_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_authnStatement() {
        $array = LassoSaml2Assertion_authnStatement_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_authnStatement($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Assertion_authnStatement_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_authzDecisionStatement() {
        $array = LassoSaml2Assertion_authzDecisionStatement_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_authzDecisionStatement($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Assertion_authzDecisionStatement_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_attributeStatement() {
        $array = LassoSaml2Assertion_attributeStatement_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_attributeStatement($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Assertion_attributeStatement_set($this->_cptr, $array);
    }

    /**
     * @return string
     */
    protected function get_version() {
        return LassoSaml2Assertion_version_get($this->_cptr);
    }
    protected function set_version($value) {
        LassoSaml2Assertion_version_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_iD() {
        return LassoSaml2Assertion_iD_get($this->_cptr);
    }
    protected function set_iD($value) {
        LassoSaml2Assertion_iD_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_issueInstant() {
        return LassoSaml2Assertion_issueInstant_get($this->_cptr);
    }
    protected function set_issueInstant($value) {
        LassoSaml2Assertion_issueInstant_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AssertionNoInit extends LassoSaml2Assertion {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Attribute extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_attribute_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Attribute  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_attributeValue() {
        $array = LassoSaml2Attribute_attributeValue_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_attributeValue($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Attribute_attributeValue_set($this->_cptr, $array);
    }

    /**
     * @return string
     */
    protected function get_name() {
        return LassoSaml2Attribute_name_get($this->_cptr);
    }
    protected function set_name($value) {
        LassoSaml2Attribute_name_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_nameFormat() {
        return LassoSaml2Attribute_nameFormat_get($this->_cptr);
    }
    protected function set_nameFormat($value) {
        LassoSaml2Attribute_nameFormat_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_friendlyName() {
        return LassoSaml2Attribute_friendlyName_get($this->_cptr);
    }
    protected function set_friendlyName($value) {
        LassoSaml2Attribute_friendlyName_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AttributeNoInit extends LassoSaml2Attribute {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2AttributeValue extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_attribute_value_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2AttributeValue  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_any() {
        $array = LassoSaml2AttributeValue_any_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_any($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2AttributeValue_any_set($this->_cptr, $array);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AttributeValueNoInit extends LassoSaml2AttributeValue {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2AuthnContext extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_authn_context_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2AuthnContext  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_authnContextClassRef() {
        return LassoSaml2AuthnContext_authnContextClassRef_get($this->_cptr);
    }
    protected function set_authnContextClassRef($value) {
        LassoSaml2AuthnContext_authnContextClassRef_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_authnContextDeclRef() {
        return LassoSaml2AuthnContext_authnContextDeclRef_get($this->_cptr);
    }
    protected function set_authnContextDeclRef($value) {
        LassoSaml2AuthnContext_authnContextDeclRef_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_authenticatingAuthority() {
        return LassoSaml2AuthnContext_authenticatingAuthority_get($this->_cptr);
    }
    protected function set_authenticatingAuthority($value) {
        LassoSaml2AuthnContext_authenticatingAuthority_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AuthnContextNoInit extends LassoSaml2AuthnContext {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2BaseIDAbstract extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_base_idabstract_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2BaseIDAbstract  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_nameQualifier() {
        return LassoSaml2BaseIDAbstract_nameQualifier_get($this->_cptr);
    }
    protected function set_nameQualifier($value) {
        LassoSaml2BaseIDAbstract_nameQualifier_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_sPNameQualifier() {
        return LassoSaml2BaseIDAbstract_sPNameQualifier_get($this->_cptr);
    }
    protected function set_sPNameQualifier($value) {
        LassoSaml2BaseIDAbstract_sPNameQualifier_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2BaseIDAbstractNoInit extends LassoSaml2BaseIDAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2ConditionAbstract extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSaml2ConditionAbstractNoInit extends LassoSaml2ConditionAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2AudienceRestriction extends LassoSaml2ConditionAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_audience_restriction_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2AudienceRestriction  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_audience() {
        return LassoSaml2AudienceRestriction_audience_get($this->_cptr);
    }
    protected function set_audience($value) {
        LassoSaml2AudienceRestriction_audience_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AudienceRestrictionNoInit extends LassoSaml2AudienceRestriction {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Conditions extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_conditions_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Conditions  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_condition() {
        $array = LassoSaml2Conditions_condition_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_condition($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Conditions_condition_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_audienceRestriction() {
        $array = LassoSaml2Conditions_audienceRestriction_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_audienceRestriction($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Conditions_audienceRestriction_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_oneTimeUse() {
        $array = LassoSaml2Conditions_oneTimeUse_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_oneTimeUse($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Conditions_oneTimeUse_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_proxyRestriction() {
        $array = LassoSaml2Conditions_proxyRestriction_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_proxyRestriction($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Conditions_proxyRestriction_set($this->_cptr, $array);
    }

    /**
     * @return string
     */
    protected function get_notBefore() {
        return LassoSaml2Conditions_notBefore_get($this->_cptr);
    }
    protected function set_notBefore($value) {
        LassoSaml2Conditions_notBefore_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_notOnOrAfter() {
        return LassoSaml2Conditions_notOnOrAfter_get($this->_cptr);
    }
    protected function set_notOnOrAfter($value) {
        LassoSaml2Conditions_notOnOrAfter_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2ConditionsNoInit extends LassoSaml2Conditions {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2EncryptedElement extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_encrypted_element_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2EncryptedElement  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_encryptedData() {
        return LassoSaml2EncryptedElement_encryptedData_get($this->_cptr);
    }
    protected function set_encryptedData($value) {
        LassoSaml2EncryptedElement_encryptedData_set($this->_cptr, $value);
    }

    /**
     * @return array
     */
    protected function get_encryptedKey() {
        $array = LassoSaml2EncryptedElement_encryptedKey_get($this->_cptr);
        return $array;
    }
    protected function set_encryptedKey($value) {
        LassoSaml2EncryptedElement_encryptedKey_set($this->_cptr, $value);
    }

    /**
     * @return LassoNode
     */
    protected function get_originalData() {
        return cptrToPhp(LassoSaml2EncryptedElement_originalData_get($this->_cptr));
    }
    protected function set_originalData($value) {
        LassoSaml2EncryptedElement_originalData_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2EncryptedElementNoInit extends LassoSaml2EncryptedElement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Evidence extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_evidence_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Evidence  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_assertionIdRef() {
        $array = LassoSaml2Evidence_assertionIdRef_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_assertionIdRef($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Evidence_assertionIdRef_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_assertionURIRef() {
        $array = LassoSaml2Evidence_assertionURIRef_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_assertionURIRef($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Evidence_assertionURIRef_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_assertion() {
        $array = LassoSaml2Evidence_assertion_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_assertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Evidence_assertion_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_encryptedAssertion() {
        $array = LassoSaml2Evidence_encryptedAssertion_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_encryptedAssertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2Evidence_encryptedAssertion_set($this->_cptr, $array);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2EvidenceNoInit extends LassoSaml2Evidence {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2KeyInfoConfirmationData extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSaml2KeyInfoConfirmationDataNoInit extends LassoSaml2KeyInfoConfirmationData {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2NameID extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_name_id_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2NameID  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_content() {
        return LassoSaml2NameID_content_get($this->_cptr);
    }
    protected function set_content($value) {
        LassoSaml2NameID_content_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_format() {
        return LassoSaml2NameID_format_get($this->_cptr);
    }
    protected function set_format($value) {
        LassoSaml2NameID_format_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_sPProvidedId() {
        return LassoSaml2NameID_sPProvidedId_get($this->_cptr);
    }
    protected function set_sPProvidedId($value) {
        LassoSaml2NameID_sPProvidedId_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_nameQualifier() {
        return LassoSaml2NameID_nameQualifier_get($this->_cptr);
    }
    protected function set_nameQualifier($value) {
        LassoSaml2NameID_nameQualifier_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_sPNameQualifier() {
        return LassoSaml2NameID_sPNameQualifier_get($this->_cptr);
    }
    protected function set_sPNameQualifier($value) {
        LassoSaml2NameID_sPNameQualifier_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2NameIDNoInit extends LassoSaml2NameID {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2OneTimeUse extends LassoSaml2ConditionAbstract {
}

/**
 * @package Lasso
 */
class LassoSaml2OneTimeUseNoInit extends LassoSaml2OneTimeUse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2ProxyRestriction extends LassoSaml2ConditionAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_proxy_restriction_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2ProxyRestriction  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_audience() {
        return LassoSaml2ProxyRestriction_audience_get($this->_cptr);
    }
    protected function set_audience($value) {
        LassoSaml2ProxyRestriction_audience_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_count() {
        return LassoSaml2ProxyRestriction_count_get($this->_cptr);
    }
    protected function set_count($value) {
        LassoSaml2ProxyRestriction_count_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2ProxyRestrictionNoInit extends LassoSaml2ProxyRestriction {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2StatementAbstract extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSaml2StatementAbstractNoInit extends LassoSaml2StatementAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2AttributeStatement extends LassoSaml2StatementAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_attribute_statement_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2AttributeStatement  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_attribute() {
        $array = LassoSaml2AttributeStatement_attribute_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_attribute($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2AttributeStatement_attribute_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_encryptedAttribute() {
        $array = LassoSaml2AttributeStatement_encryptedAttribute_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_encryptedAttribute($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSaml2AttributeStatement_encryptedAttribute_set($this->_cptr, $array);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AttributeStatementNoInit extends LassoSaml2AttributeStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2AuthnStatement extends LassoSaml2StatementAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_authn_statement_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2AuthnStatement  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2SubjectLocality
     */
    protected function get_subjectLocality() {
        return cptrToPhp(LassoSaml2AuthnStatement_subjectLocality_get($this->_cptr));
    }
    protected function set_subjectLocality($value) {
        LassoSaml2AuthnStatement_subjectLocality_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2AuthnContext
     */
    protected function get_authnContext() {
        return cptrToPhp(LassoSaml2AuthnStatement_authnContext_get($this->_cptr));
    }
    protected function set_authnContext($value) {
        LassoSaml2AuthnStatement_authnContext_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_authnInstant() {
        return LassoSaml2AuthnStatement_authnInstant_get($this->_cptr);
    }
    protected function set_authnInstant($value) {
        LassoSaml2AuthnStatement_authnInstant_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_sessionIndex() {
        return LassoSaml2AuthnStatement_sessionIndex_get($this->_cptr);
    }
    protected function set_sessionIndex($value) {
        LassoSaml2AuthnStatement_sessionIndex_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_sessionNotOnOrAfter() {
        return LassoSaml2AuthnStatement_sessionNotOnOrAfter_get($this->_cptr);
    }
    protected function set_sessionNotOnOrAfter($value) {
        LassoSaml2AuthnStatement_sessionNotOnOrAfter_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AuthnStatementNoInit extends LassoSaml2AuthnStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2AuthzDecisionStatement extends LassoSaml2StatementAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_authz_decision_statement_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2AuthzDecisionStatement  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2Action
     */
    protected function get_action() {
        return cptrToPhp(LassoSaml2AuthzDecisionStatement_action_get($this->_cptr));
    }
    protected function set_action($value) {
        LassoSaml2AuthzDecisionStatement_action_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2Evidence
     */
    protected function get_evidence() {
        return cptrToPhp(LassoSaml2AuthzDecisionStatement_evidence_get($this->_cptr));
    }
    protected function set_evidence($value) {
        LassoSaml2AuthzDecisionStatement_evidence_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_resource() {
        return LassoSaml2AuthzDecisionStatement_resource_get($this->_cptr);
    }
    protected function set_resource($value) {
        LassoSaml2AuthzDecisionStatement_resource_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_decision() {
        return LassoSaml2AuthzDecisionStatement_decision_get($this->_cptr);
    }
    protected function set_decision($value) {
        LassoSaml2AuthzDecisionStatement_decision_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2AuthzDecisionStatementNoInit extends LassoSaml2AuthzDecisionStatement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2SubjectConfirmationData extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_subject_confirmation_data_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2SubjectConfirmationData  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_notBefore() {
        return LassoSaml2SubjectConfirmationData_notBefore_get($this->_cptr);
    }
    protected function set_notBefore($value) {
        LassoSaml2SubjectConfirmationData_notBefore_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_notOnOrAfter() {
        return LassoSaml2SubjectConfirmationData_notOnOrAfter_get($this->_cptr);
    }
    protected function set_notOnOrAfter($value) {
        LassoSaml2SubjectConfirmationData_notOnOrAfter_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_recipient() {
        return LassoSaml2SubjectConfirmationData_recipient_get($this->_cptr);
    }
    protected function set_recipient($value) {
        LassoSaml2SubjectConfirmationData_recipient_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_inResponseTo() {
        return LassoSaml2SubjectConfirmationData_inResponseTo_get($this->_cptr);
    }
    protected function set_inResponseTo($value) {
        LassoSaml2SubjectConfirmationData_inResponseTo_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_address() {
        return LassoSaml2SubjectConfirmationData_address_get($this->_cptr);
    }
    protected function set_address($value) {
        LassoSaml2SubjectConfirmationData_address_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2SubjectConfirmationDataNoInit extends LassoSaml2SubjectConfirmationData {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2SubjectConfirmation extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_subject_confirmation_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2SubjectConfirmation  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2BaseIDAbstract
     */
    protected function get_baseId() {
        return cptrToPhp(LassoSaml2SubjectConfirmation_baseId_get($this->_cptr));
    }
    protected function set_baseId($value) {
        LassoSaml2SubjectConfirmation_baseId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2NameID
     */
    protected function get_nameId() {
        return cptrToPhp(LassoSaml2SubjectConfirmation_nameId_get($this->_cptr));
    }
    protected function set_nameId($value) {
        LassoSaml2SubjectConfirmation_nameId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2EncryptedElement
     */
    protected function get_encryptedId() {
        return cptrToPhp(LassoSaml2SubjectConfirmation_encryptedId_get($this->_cptr));
    }
    protected function set_encryptedId($value) {
        LassoSaml2SubjectConfirmation_encryptedId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2SubjectConfirmationData
     */
    protected function get_subjectConfirmationData() {
        return cptrToPhp(LassoSaml2SubjectConfirmation_subjectConfirmationData_get($this->_cptr));
    }
    protected function set_subjectConfirmationData($value) {
        LassoSaml2SubjectConfirmation_subjectConfirmationData_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_method() {
        return LassoSaml2SubjectConfirmation_method_get($this->_cptr);
    }
    protected function set_method($value) {
        LassoSaml2SubjectConfirmation_method_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2SubjectConfirmationNoInit extends LassoSaml2SubjectConfirmation {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2Subject extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_subject_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2Subject  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2BaseIDAbstract
     */
    protected function get_baseId() {
        return cptrToPhp(LassoSaml2Subject_baseId_get($this->_cptr));
    }
    protected function set_baseId($value) {
        LassoSaml2Subject_baseId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2NameID
     */
    protected function get_nameId() {
        return cptrToPhp(LassoSaml2Subject_nameId_get($this->_cptr));
    }
    protected function set_nameId($value) {
        LassoSaml2Subject_nameId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2EncryptedElement
     */
    protected function get_encryptedId() {
        return cptrToPhp(LassoSaml2Subject_encryptedId_get($this->_cptr));
    }
    protected function set_encryptedId($value) {
        LassoSaml2Subject_encryptedId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2SubjectConfirmation
     */
    protected function get_subjectConfirmation() {
        return cptrToPhp(LassoSaml2Subject_subjectConfirmation_get($this->_cptr));
    }
    protected function set_subjectConfirmation($value) {
        LassoSaml2Subject_subjectConfirmation_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2SubjectNoInit extends LassoSaml2Subject {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSaml2SubjectLocality extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_saml2_subject_locality_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSaml2SubjectLocality  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_address() {
        return LassoSaml2SubjectLocality_address_get($this->_cptr);
    }
    protected function set_address($value) {
        LassoSaml2SubjectLocality_address_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_dNSName() {
        return LassoSaml2SubjectLocality_dNSName_get($this->_cptr);
    }
    protected function set_dNSName($value) {
        LassoSaml2SubjectLocality_dNSName_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSaml2SubjectLocalityNoInit extends LassoSaml2SubjectLocality {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2Extensions extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSamlp2ExtensionsNoInit extends LassoSamlp2Extensions {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2IDPEntry extends LassoNode {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_providerId() {
        return LassoSamlp2IDPEntry_providerId_get($this->_cptr);
    }
    protected function set_providerId($value) {
        LassoSamlp2IDPEntry_providerId_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_name() {
        return LassoSamlp2IDPEntry_name_get($this->_cptr);
    }
    protected function set_name($value) {
        LassoSamlp2IDPEntry_name_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_loc() {
        return LassoSamlp2IDPEntry_loc_get($this->_cptr);
    }
    protected function set_loc($value) {
        LassoSamlp2IDPEntry_loc_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2IDPEntryNoInit extends LassoSamlp2IDPEntry {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2IDPList extends LassoNode {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlp2IDPEntry
     */
    protected function get_iDPEntry() {
        return cptrToPhp(LassoSamlp2IDPList_iDPEntry_get($this->_cptr));
    }
    protected function set_iDPEntry($value) {
        LassoSamlp2IDPList_iDPEntry_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_getComplete() {
        return LassoSamlp2IDPList_getComplete_get($this->_cptr);
    }
    protected function set_getComplete($value) {
        LassoSamlp2IDPList_getComplete_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2IDPListNoInit extends LassoSamlp2IDPList {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2NameIDPolicy extends LassoNode {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_format() {
        return LassoSamlp2NameIDPolicy_format_get($this->_cptr);
    }
    protected function set_format($value) {
        LassoSamlp2NameIDPolicy_format_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_sPNameQualifier() {
        return LassoSamlp2NameIDPolicy_sPNameQualifier_get($this->_cptr);
    }
    protected function set_sPNameQualifier($value) {
        LassoSamlp2NameIDPolicy_sPNameQualifier_set($this->_cptr, $value);
    }

    /**
     * @return boolean
     */
    protected function get_allowCreate() {
        return LassoSamlp2NameIDPolicy_allowCreate_get($this->_cptr);
    }
    protected function set_allowCreate($value) {
        LassoSamlp2NameIDPolicy_allowCreate_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2NameIDPolicyNoInit extends LassoSamlp2NameIDPolicy {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2RequestAbstract extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_request_abstract_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2RequestAbstract  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2NameID
     */
    protected function get_issuer() {
        return cptrToPhp(LassoSamlp2RequestAbstract_issuer_get($this->_cptr));
    }
    protected function set_issuer($value) {
        LassoSamlp2RequestAbstract_issuer_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlp2Extensions
     */
    protected function get_extensions() {
        return cptrToPhp(LassoSamlp2RequestAbstract_extensions_get($this->_cptr));
    }
    protected function set_extensions($value) {
        LassoSamlp2RequestAbstract_extensions_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_iD() {
        return LassoSamlp2RequestAbstract_iD_get($this->_cptr);
    }
    protected function set_iD($value) {
        LassoSamlp2RequestAbstract_iD_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_version() {
        return LassoSamlp2RequestAbstract_version_get($this->_cptr);
    }
    protected function set_version($value) {
        LassoSamlp2RequestAbstract_version_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_issueInstant() {
        return LassoSamlp2RequestAbstract_issueInstant_get($this->_cptr);
    }
    protected function set_issueInstant($value) {
        LassoSamlp2RequestAbstract_issueInstant_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_destination() {
        return LassoSamlp2RequestAbstract_destination_get($this->_cptr);
    }
    protected function set_destination($value) {
        LassoSamlp2RequestAbstract_destination_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_consent() {
        return LassoSamlp2RequestAbstract_consent_get($this->_cptr);
    }
    protected function set_consent($value) {
        LassoSamlp2RequestAbstract_consent_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2RequestAbstractNoInit extends LassoSamlp2RequestAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2ArtifactResolve extends LassoSamlp2RequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_artifact_resolve_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2ArtifactResolve  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_artifact() {
        return LassoSamlp2ArtifactResolve_artifact_get($this->_cptr);
    }
    protected function set_artifact($value) {
        LassoSamlp2ArtifactResolve_artifact_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2ArtifactResolveNoInit extends LassoSamlp2ArtifactResolve {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2AssertionIDRequest extends LassoSamlp2RequestAbstract {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_assertionIdRef() {
        return LassoSamlp2AssertionIDRequest_assertionIdRef_get($this->_cptr);
    }
    protected function set_assertionIdRef($value) {
        LassoSamlp2AssertionIDRequest_assertionIdRef_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2AssertionIDRequestNoInit extends LassoSamlp2AssertionIDRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2AuthnRequest extends LassoSamlp2RequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_authn_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2AuthnRequest  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2Subject
     */
    protected function get_subject() {
        return cptrToPhp(LassoSamlp2AuthnRequest_subject_get($this->_cptr));
    }
    protected function set_subject($value) {
        LassoSamlp2AuthnRequest_subject_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlp2NameIDPolicy
     */
    protected function get_nameIdPolicy() {
        return cptrToPhp(LassoSamlp2AuthnRequest_nameIdPolicy_get($this->_cptr));
    }
    protected function set_nameIdPolicy($value) {
        LassoSamlp2AuthnRequest_nameIdPolicy_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2Conditions
     */
    protected function get_conditions() {
        return cptrToPhp(LassoSamlp2AuthnRequest_conditions_get($this->_cptr));
    }
    protected function set_conditions($value) {
        LassoSamlp2AuthnRequest_conditions_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlp2RequestedAuthnContext
     */
    protected function get_requestedAuthnContext() {
        return cptrToPhp(LassoSamlp2AuthnRequest_requestedAuthnContext_get($this->_cptr));
    }
    protected function set_requestedAuthnContext($value) {
        LassoSamlp2AuthnRequest_requestedAuthnContext_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlp2Scoping
     */
    protected function get_scoping() {
        return cptrToPhp(LassoSamlp2AuthnRequest_scoping_get($this->_cptr));
    }
    protected function set_scoping($value) {
        LassoSamlp2AuthnRequest_scoping_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return boolean
     */
    protected function get_forceAuthn() {
        return LassoSamlp2AuthnRequest_forceAuthn_get($this->_cptr);
    }
    protected function set_forceAuthn($value) {
        LassoSamlp2AuthnRequest_forceAuthn_set($this->_cptr, $value);
    }

    /**
     * @return boolean
     */
    protected function get_isPassive() {
        return LassoSamlp2AuthnRequest_isPassive_get($this->_cptr);
    }
    protected function set_isPassive($value) {
        LassoSamlp2AuthnRequest_isPassive_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_protocolBinding() {
        return LassoSamlp2AuthnRequest_protocolBinding_get($this->_cptr);
    }
    protected function set_protocolBinding($value) {
        LassoSamlp2AuthnRequest_protocolBinding_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_assertionConsumerServiceIndex() {
        return LassoSamlp2AuthnRequest_assertionConsumerServiceIndex_get($this->_cptr);
    }
    protected function set_assertionConsumerServiceIndex($value) {
        LassoSamlp2AuthnRequest_assertionConsumerServiceIndex_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_assertionConsumerServiceURL() {
        return LassoSamlp2AuthnRequest_assertionConsumerServiceURL_get($this->_cptr);
    }
    protected function set_assertionConsumerServiceURL($value) {
        LassoSamlp2AuthnRequest_assertionConsumerServiceURL_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_attributeConsumingServiceIndex() {
        return LassoSamlp2AuthnRequest_attributeConsumingServiceIndex_get($this->_cptr);
    }
    protected function set_attributeConsumingServiceIndex($value) {
        LassoSamlp2AuthnRequest_attributeConsumingServiceIndex_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_providerName() {
        return LassoSamlp2AuthnRequest_providerName_get($this->_cptr);
    }
    protected function set_providerName($value) {
        LassoSamlp2AuthnRequest_providerName_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_relayState() {
        return LassoSamlp2AuthnRequest_relayState_get($this->_cptr);
    }
    protected function set_relayState($value) {
        LassoSamlp2AuthnRequest_relayState_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2AuthnRequestNoInit extends LassoSamlp2AuthnRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2LogoutRequest extends LassoSamlp2RequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_logout_request_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2LogoutRequest  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2BaseIDAbstract
     */
    protected function get_baseId() {
        return cptrToPhp(LassoSamlp2LogoutRequest_baseId_get($this->_cptr));
    }
    protected function set_baseId($value) {
        LassoSamlp2LogoutRequest_baseId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2NameID
     */
    protected function get_nameId() {
        return cptrToPhp(LassoSamlp2LogoutRequest_nameId_get($this->_cptr));
    }
    protected function set_nameId($value) {
        LassoSamlp2LogoutRequest_nameId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2EncryptedElement
     */
    protected function get_encryptedId() {
        return cptrToPhp(LassoSamlp2LogoutRequest_encryptedId_get($this->_cptr));
    }
    protected function set_encryptedId($value) {
        LassoSamlp2LogoutRequest_encryptedId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_sessionIndex() {
        return LassoSamlp2LogoutRequest_sessionIndex_get($this->_cptr);
    }
    protected function set_sessionIndex($value) {
        LassoSamlp2LogoutRequest_sessionIndex_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_reason() {
        return LassoSamlp2LogoutRequest_reason_get($this->_cptr);
    }
    protected function set_reason($value) {
        LassoSamlp2LogoutRequest_reason_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_notOnOrAfter() {
        return LassoSamlp2LogoutRequest_notOnOrAfter_get($this->_cptr);
    }
    protected function set_notOnOrAfter($value) {
        LassoSamlp2LogoutRequest_notOnOrAfter_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_relayState() {
        return LassoSamlp2LogoutRequest_relayState_get($this->_cptr);
    }
    protected function set_relayState($value) {
        LassoSamlp2LogoutRequest_relayState_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2LogoutRequestNoInit extends LassoSamlp2LogoutRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2ManageNameIDRequest extends LassoSamlp2RequestAbstract {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2NameID
     */
    protected function get_nameId() {
        return cptrToPhp(LassoSamlp2ManageNameIDRequest_nameId_get($this->_cptr));
    }
    protected function set_nameId($value) {
        LassoSamlp2ManageNameIDRequest_nameId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2EncryptedElement
     */
    protected function get_encryptedId() {
        return cptrToPhp(LassoSamlp2ManageNameIDRequest_encryptedId_get($this->_cptr));
    }
    protected function set_encryptedId($value) {
        LassoSamlp2ManageNameIDRequest_encryptedId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_newId() {
        return LassoSamlp2ManageNameIDRequest_newId_get($this->_cptr);
    }
    protected function set_newId($value) {
        LassoSamlp2ManageNameIDRequest_newId_set($this->_cptr, $value);
    }

    /**
     * @return LassoSaml2EncryptedElement
     */
    protected function get_newEncryptedId() {
        return cptrToPhp(LassoSamlp2ManageNameIDRequest_newEncryptedId_get($this->_cptr));
    }
    protected function set_newEncryptedId($value) {
        LassoSamlp2ManageNameIDRequest_newEncryptedId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlp2Terminate
     */
    protected function get_terminate() {
        return cptrToPhp(LassoSamlp2ManageNameIDRequest_terminate_get($this->_cptr));
    }
    protected function set_terminate($value) {
        LassoSamlp2ManageNameIDRequest_terminate_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2ManageNameIDRequestNoInit extends LassoSamlp2ManageNameIDRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2NameIDMappingRequest extends LassoSamlp2RequestAbstract {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2BaseIDAbstract
     */
    protected function get_baseId() {
        return cptrToPhp(LassoSamlp2NameIDMappingRequest_baseId_get($this->_cptr));
    }
    protected function set_baseId($value) {
        LassoSamlp2NameIDMappingRequest_baseId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2NameID
     */
    protected function get_nameId() {
        return cptrToPhp(LassoSamlp2NameIDMappingRequest_nameId_get($this->_cptr));
    }
    protected function set_nameId($value) {
        LassoSamlp2NameIDMappingRequest_nameId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2EncryptedElement
     */
    protected function get_encryptedId() {
        return cptrToPhp(LassoSamlp2NameIDMappingRequest_encryptedId_get($this->_cptr));
    }
    protected function set_encryptedId($value) {
        LassoSamlp2NameIDMappingRequest_encryptedId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlp2NameIDPolicy
     */
    protected function get_nameIdPolicy() {
        return cptrToPhp(LassoSamlp2NameIDMappingRequest_nameIdPolicy_get($this->_cptr));
    }
    protected function set_nameIdPolicy($value) {
        LassoSamlp2NameIDMappingRequest_nameIdPolicy_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2NameIDMappingRequestNoInit extends LassoSamlp2NameIDMappingRequest {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2RequestedAuthnContext extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_requested_authn_context_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2RequestedAuthnContext  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_authnContextClassRef() {
        $array = LassoSamlp2RequestedAuthnContext_authnContextClassRef_get($this->_cptr);
        return $array;
    }
    protected function set_authnContextClassRef($value) {
        LassoSamlp2RequestedAuthnContext_authnContextClassRef_set($this->_cptr, $value);
    }

    /**
     * @return array
     */
    protected function get_authnContextDeclRef() {
        $array = LassoSamlp2RequestedAuthnContext_authnContextDeclRef_get($this->_cptr);
        return $array;
    }
    protected function set_authnContextDeclRef($value) {
        LassoSamlp2RequestedAuthnContext_authnContextDeclRef_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_comparison() {
        return LassoSamlp2RequestedAuthnContext_comparison_get($this->_cptr);
    }
    protected function set_comparison($value) {
        LassoSamlp2RequestedAuthnContext_comparison_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2RequestedAuthnContextNoInit extends LassoSamlp2RequestedAuthnContext {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2Scoping extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_scoping_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2Scoping  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlp2IDPList
     */
    protected function get_iDPList() {
        return cptrToPhp(LassoSamlp2Scoping_iDPList_get($this->_cptr));
    }
    protected function set_iDPList($value) {
        LassoSamlp2Scoping_iDPList_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_requesterId() {
        return LassoSamlp2Scoping_requesterId_get($this->_cptr);
    }
    protected function set_requesterId($value) {
        LassoSamlp2Scoping_requesterId_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_proxyCount() {
        return LassoSamlp2Scoping_proxyCount_get($this->_cptr);
    }
    protected function set_proxyCount($value) {
        LassoSamlp2Scoping_proxyCount_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2ScopingNoInit extends LassoSamlp2Scoping {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2StatusCode extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_status_code_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2StatusCode  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlp2StatusCode
     */
    protected function get_statusCode() {
        return cptrToPhp(LassoSamlp2StatusCode_statusCode_get($this->_cptr));
    }
    protected function set_statusCode($value) {
        LassoSamlp2StatusCode_statusCode_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_value() {
        return LassoSamlp2StatusCode_value_get($this->_cptr);
    }
    protected function set_value($value) {
        LassoSamlp2StatusCode_value_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2StatusCodeNoInit extends LassoSamlp2StatusCode {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2StatusDetail extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSamlp2StatusDetailNoInit extends LassoSamlp2StatusDetail {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2Status extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_status_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2Status  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlp2StatusCode
     */
    protected function get_statusCode() {
        return cptrToPhp(LassoSamlp2Status_statusCode_get($this->_cptr));
    }
    protected function set_statusCode($value) {
        LassoSamlp2Status_statusCode_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_statusMessage() {
        return LassoSamlp2Status_statusMessage_get($this->_cptr);
    }
    protected function set_statusMessage($value) {
        LassoSamlp2Status_statusMessage_set($this->_cptr, $value);
    }

    /**
     * @return LassoSamlp2StatusDetail
     */
    protected function get_statusDetail() {
        return cptrToPhp(LassoSamlp2Status_statusDetail_get($this->_cptr));
    }
    protected function set_statusDetail($value) {
        LassoSamlp2Status_statusDetail_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2StatusNoInit extends LassoSamlp2Status {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2StatusResponse extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_status_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2StatusResponse  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2NameID
     */
    protected function get_issuer() {
        return cptrToPhp(LassoSamlp2StatusResponse_issuer_get($this->_cptr));
    }
    protected function set_issuer($value) {
        LassoSamlp2StatusResponse_issuer_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlp2Extensions
     */
    protected function get_extensions() {
        return cptrToPhp(LassoSamlp2StatusResponse_extensions_get($this->_cptr));
    }
    protected function set_extensions($value) {
        LassoSamlp2StatusResponse_extensions_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSamlp2Status
     */
    protected function get_status() {
        return cptrToPhp(LassoSamlp2StatusResponse_status_get($this->_cptr));
    }
    protected function set_status($value) {
        LassoSamlp2StatusResponse_status_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_iD() {
        return LassoSamlp2StatusResponse_iD_get($this->_cptr);
    }
    protected function set_iD($value) {
        LassoSamlp2StatusResponse_iD_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_inResponseTo() {
        return LassoSamlp2StatusResponse_inResponseTo_get($this->_cptr);
    }
    protected function set_inResponseTo($value) {
        LassoSamlp2StatusResponse_inResponseTo_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_version() {
        return LassoSamlp2StatusResponse_version_get($this->_cptr);
    }
    protected function set_version($value) {
        LassoSamlp2StatusResponse_version_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_issueInstant() {
        return LassoSamlp2StatusResponse_issueInstant_get($this->_cptr);
    }
    protected function set_issueInstant($value) {
        LassoSamlp2StatusResponse_issueInstant_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_destination() {
        return LassoSamlp2StatusResponse_destination_get($this->_cptr);
    }
    protected function set_destination($value) {
        LassoSamlp2StatusResponse_destination_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_consent() {
        return LassoSamlp2StatusResponse_consent_get($this->_cptr);
    }
    protected function set_consent($value) {
        LassoSamlp2StatusResponse_consent_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2StatusResponseNoInit extends LassoSamlp2StatusResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2ArtifactResponse extends LassoSamlp2StatusResponse {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_artifact_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2ArtifactResponse  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoNode
     */
    protected function get_any() {
        return cptrToPhp(LassoSamlp2ArtifactResponse_any_get($this->_cptr));
    }
    protected function set_any($value) {
        LassoSamlp2ArtifactResponse_any_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2ArtifactResponseNoInit extends LassoSamlp2ArtifactResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2LogoutResponse extends LassoSamlp2StatusResponse {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_logout_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2LogoutResponse  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_relayState() {
        return LassoSamlp2LogoutResponse_relayState_get($this->_cptr);
    }
    protected function set_relayState($value) {
        LassoSamlp2LogoutResponse_relayState_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2LogoutResponseNoInit extends LassoSamlp2LogoutResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2ManageNameIDResponse extends LassoSamlp2StatusResponse {
}

/**
 * @package Lasso
 */
class LassoSamlp2ManageNameIDResponseNoInit extends LassoSamlp2ManageNameIDResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2NameIDMappingResponse extends LassoSamlp2StatusResponse {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2NameID
     */
    protected function get_nameId() {
        return cptrToPhp(LassoSamlp2NameIDMappingResponse_nameId_get($this->_cptr));
    }
    protected function set_nameId($value) {
        LassoSamlp2NameIDMappingResponse_nameId_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2EncryptedElement
     */
    protected function get_encryptedId() {
        return cptrToPhp(LassoSamlp2NameIDMappingResponse_encryptedId_get($this->_cptr));
    }
    protected function set_encryptedId($value) {
        LassoSamlp2NameIDMappingResponse_encryptedId_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2NameIDMappingResponseNoInit extends LassoSamlp2NameIDMappingResponse {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2Response extends LassoSamlp2StatusResponse {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_response_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2Response  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_assertion() {
        $array = LassoSamlp2Response_assertion_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_assertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlp2Response_assertion_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_encryptedAssertion() {
        $array = LassoSamlp2Response_encryptedAssertion_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_encryptedAssertion($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlp2Response_encryptedAssertion_set($this->_cptr, $array);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2ResponseNoInit extends LassoSamlp2Response {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2SubjectQueryAbstract extends LassoSamlp2RequestAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_subject_query_abstract_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2SubjectQueryAbstract  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2Subject
     */
    protected function get_subject() {
        return cptrToPhp(LassoSamlp2SubjectQueryAbstract_subject_get($this->_cptr));
    }
    protected function set_subject($value) {
        LassoSamlp2SubjectQueryAbstract_subject_set($this->_cptr, $value->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2SubjectQueryAbstractNoInit extends LassoSamlp2SubjectQueryAbstract {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2AttributeQuery extends LassoSamlp2SubjectQueryAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_attribute_query_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2AttributeQuery  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_attribute() {
        $array = LassoSamlp2AttributeQuery_attribute_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $item) {
            $obj_array[] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_attribute($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $item) {
                $array[] = $item->_cptr;
            }
        }
        LassoSamlp2AttributeQuery_attribute_set($this->_cptr, $array);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2AttributeQueryNoInit extends LassoSamlp2AttributeQuery {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2AuthnQuery extends LassoSamlp2SubjectQueryAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_authn_query_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2AuthnQuery  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlp2RequestedAuthnContext
     */
    protected function get_requestedAuthnContext() {
        return cptrToPhp(LassoSamlp2AuthnQuery_requestedAuthnContext_get($this->_cptr));
    }
    protected function set_requestedAuthnContext($value) {
        LassoSamlp2AuthnQuery_requestedAuthnContext_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_sessionIndex() {
        return LassoSamlp2AuthnQuery_sessionIndex_get($this->_cptr);
    }
    protected function set_sessionIndex($value) {
        LassoSamlp2AuthnQuery_sessionIndex_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2AuthnQueryNoInit extends LassoSamlp2AuthnQuery {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2AuthzDecisionQuery extends LassoSamlp2SubjectQueryAbstract {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_samlp2_authz_decision_query_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSamlp2AuthzDecisionQuery  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSaml2Action
     */
    protected function get_action() {
        return cptrToPhp(LassoSamlp2AuthzDecisionQuery_action_get($this->_cptr));
    }
    protected function set_action($value) {
        LassoSamlp2AuthzDecisionQuery_action_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoSaml2Evidence
     */
    protected function get_evidence() {
        return cptrToPhp(LassoSamlp2AuthzDecisionQuery_evidence_get($this->_cptr));
    }
    protected function set_evidence($value) {
        LassoSamlp2AuthzDecisionQuery_evidence_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_resource() {
        return LassoSamlp2AuthzDecisionQuery_resource_get($this->_cptr);
    }
    protected function set_resource($value) {
        LassoSamlp2AuthzDecisionQuery_resource_set($this->_cptr, $value);
    }


}

/**
 * @package Lasso
 */
class LassoSamlp2AuthzDecisionQueryNoInit extends LassoSamlp2AuthzDecisionQuery {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSamlp2Terminate extends LassoNode {
}

/**
 * @package Lasso
 */
class LassoSamlp2TerminateNoInit extends LassoSamlp2Terminate {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoFederation extends LassoNode {
    public $_cptr = null;

    public function __construct($remote_providerID) {
        $this->_cptr = lasso_federation_new($remote_providerID);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoFederation  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_remoteProviderId() {
        return LassoFederation_remoteProviderId_get($this->_cptr);
    }
    protected function set_remoteProviderId($value) {
        LassoFederation_remoteProviderId_set($this->_cptr, $value);
    }

    /**
     * @return LassoNode
     */
    protected function get_localNameIdentifier() {
        return cptrToPhp(LassoFederation_localNameIdentifier_get($this->_cptr));
    }
    protected function set_localNameIdentifier($value) {
        LassoFederation_localNameIdentifier_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoNode
     */
    protected function get_remoteNameIdentifier() {
        return cptrToPhp(LassoFederation_remoteNameIdentifier_get($this->_cptr));
    }
    protected function set_remoteNameIdentifier($value) {
        LassoFederation_remoteNameIdentifier_set($this->_cptr, $value->_cptr);
    }

    /**
     * Builds federation local name identifier.
     */
    public function buildLocalNameIdentifier($nameQualifier, $format, $content) {
        return lasso_federation_build_local_name_identifier($this->_cptr, $nameQualifier, $format, $content);
    }

    /**
     * Checks whether federation is for $name_identifier.
     * 
     * @return boolean TRUE if the federation is for $name_identifier.
     */
    public function verifyNameIdentifier($name_identifier) {
        return lasso_federation_verify_name_identifier($this->_cptr, $name_identifier._cptr);
    }


}

/**
 * @package Lasso
 */
class LassoFederationNoInit extends LassoFederation {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoIdentity extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_identity_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoIdentity  failed "); }
    }

    public static function newFromDump($dump) {
        return cptrToPhp(lasso_identity_new_from_dump($dump));
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_federations() {
        $array = LassoIdentity_federations_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $key => $item) {
            $obj_array[$key] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_federations($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        LassoIdentity_federations_set($this->_cptr, $array);
    }

    /**
     * @return boolean
     */
    protected function get_isDirty() {
        return LassoIdentity_isDirty_get($this->_cptr);
    }
    protected function set_isDirty($value) {
        LassoIdentity_isDirty_set($this->_cptr, $value);
    }

    /**
     * Looks up and returns the LassoFederation for this provider ID.
     * 
     * @return LassoFederation the LassoFederation; or NULL if it didn't exist.  The
     *      LassoFederation is internally allocated.  It must not be freed,
     *      modified or stored.
     */
    public function getFederation($providerID) {
        return lasso_identity_get_federation($this->_cptr, $providerID);
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * @return string the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_identity_dump($this->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoIdentityNoInit extends LassoIdentity {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoProfile extends LassoNode {
    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoServer
     */
    protected function get_server() {
        return cptrToPhp(LassoProfile_server_get($this->_cptr));
    }
    protected function set_server($value) {
        LassoProfile_server_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoNode
     */
    protected function get_request() {
        return cptrToPhp(LassoProfile_request_get($this->_cptr));
    }
    protected function set_request($value) {
        LassoProfile_request_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoNode
     */
    protected function get_response() {
        return cptrToPhp(LassoProfile_response_get($this->_cptr));
    }
    protected function set_response($value) {
        LassoProfile_response_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoNode
     */
    protected function get_nameIdentifier() {
        return cptrToPhp(LassoProfile_nameIdentifier_get($this->_cptr));
    }
    protected function set_nameIdentifier($value) {
        LassoProfile_nameIdentifier_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_remoteProviderId() {
        return LassoProfile_remoteProviderId_get($this->_cptr);
    }
    protected function set_remoteProviderId($value) {
        LassoProfile_remoteProviderId_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_msgUrl() {
        return LassoProfile_msgUrl_get($this->_cptr);
    }
    protected function set_msgUrl($value) {
        LassoProfile_msgUrl_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_msgBody() {
        return LassoProfile_msgBody_get($this->_cptr);
    }
    protected function set_msgBody($value) {
        LassoProfile_msgBody_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_msgRelayState() {
        return LassoProfile_msgRelayState_get($this->_cptr);
    }
    protected function set_msgRelayState($value) {
        LassoProfile_msgRelayState_set($this->_cptr, $value);
    }

    /**
     * @return LassoIdentity
     */
    protected function get_identity() {
        $cptr = lasso_profile_get_identity($this->_cptr);
        if (! is_null($cptr)) {
            return cptrToPhp($cptr);
        }
        return null;
    }

    /**
     * @return LassoSession
     */
    protected function get_session() {
        $cptr = lasso_profile_get_session($this->_cptr);
        if (! is_null($cptr)) {
            return cptrToPhp($cptr);
        }
        return null;
    }

    /**
     * @return LassoNode
     */
    protected function get_federationNameIdentifier() {
        $cptr = lasso_profile_get_federation_nameIdentifier($this->_cptr);
        if (! is_null($cptr)) {
            return cptrToPhp($cptr);
        }
        return null;
    }

    /**
     * @return string
     */
    protected function get_artifact() {
        return lasso_profile_get_artifact($this->_cptr);
    }

    /**
     * @return string
     */
    protected function get_artifactMessage() {
        return lasso_profile_get_artifact_message($this->_cptr);
    }
    protected function set_artifactMessage($value) {
        lasso_profile_set_artifact_message($this->_cptr, $value);
    }

    /**
     * Checks whether identity has been modified (and should therefore be saved).
     * 
     * @return boolean TRUE if identity has changed
     */
    public function hasDirtyIdentity() {
        return lasso_profile_has_dirty_identity($this->_cptr);
    }

    /**
     * Checks whether session has been modified (and should therefore be saved).
     * 
     * @return boolean TRUE if session has changed
     */
    public function hasDirtySession() {
        return lasso_profile_has_dirty_session($this->_cptr);
    }

    /**
     * Builds a new LassoIdentity object from XML dump and binds it to $this.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function setIdentityFromDump($dump) {
        $rc = lasso_profile_set_identity_from_dump($this->_cptr, $dump);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds a new LassoSession object from XML dump and binds it to $this.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function setSessionFromDump($dump) {
        $rc = lasso_profile_set_session_from_dump($this->_cptr, $dump);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoProfileNoInit extends LassoProfile {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoDefederation extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_defederation_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoDefederation  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * Builds the federation termination notification message.
     * 
     * It gets the federation termination notification protocol profile and:
     * <itemizedlist>
     * <listitem><para>
     *   if it is a SOAP method, then it builds the federation termination
     *   notification SOAP message, optionally signs the notification node, sets
     *   $msg_body, gets the SoapEndpoint url and sets $msg_url of the federation
     *   termination object.
     * </para></listitem>
     * <listitem><para>
     *   if it is a HTTP-Redirect method, then it builds the federation termination
     *   notification QUERY message (optionally signs the notification message),
     *   builds the federation termination notification url with federation
     *   termination service url, sets $msg_url in the federation termination
     *   object, sets $msg_body to NULL.
     * </para></listitem>
     * </itemizedlist>
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildNotificationMsg() {
        $rc = lasso_defederation_build_notification_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Sets a new federation termination notification to the remote provider id
     * with the provider id of the requester (from the server object) and the name
     * identifier of the federated principal.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function initNotification($remote_providerID = null, $http_method = LASSO_HTTP_METHOD_ANY) {
        $rc = lasso_defederation_init_notification($this->_cptr, $remote_providerID, $http_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a lib:FederationTerminationNotification message.  Rebuilds a
     * request object from the message and optionally verifies its signature.
     * 
     * Set the msg_nameIdentifier attribute with the NameIdentifier content of the
     * notification object and optionally set the msg_relayState attribute with the
     * RelayState content of the notification object.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processNotificationMsg($notification_msg) {
        $rc = lasso_defederation_process_notification_msg($this->_cptr, $notification_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Checks notification with regards to message status and principal
     * federations; update them accordingly.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function validateNotification() {
        $rc = lasso_defederation_validate_notification($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoDefederationNoInit extends LassoDefederation {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLogin extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_login_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLogin  failed "); }
    }

    public static function newFromDump($server, $dump) {
        return cptrToPhp(lasso_login_new_from_dump($server->_cptr, $dump));
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return int
     */
    protected function get_protocolProfile() {
        return LassoLogin_protocolProfile_get($this->_cptr);
    }
    protected function set_protocolProfile($value) {
        LassoLogin_protocolProfile_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_assertionArtifact() {
        return LassoLogin_assertionArtifact_get($this->_cptr);
    }
    protected function set_assertionArtifact($value) {
        LassoLogin_assertionArtifact_set($this->_cptr, $value);
    }

    /**
     * @return LassoSamlAssertion
     */
    protected function get_assertion() {
        return cptrToPhp(LassoLogin_assertion_get($this->_cptr));
    }
    protected function set_assertion($value) {
        LassoLogin_assertion_set($this->_cptr, $value->_cptr);
    }

    /**
     * Gets the assertion of the response and adds it into the session.
     * Builds a federation with the 2 name identifiers of the assertion
     * and adds it into the identity.
     * If the session or the identity are NULL, they are created.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function acceptSso() {
        $rc = lasso_login_accept_sso($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds a SAML artifact. Depending of the HTTP method, the data for the sending of
     * the artifact are stored in $msg_url (REDIRECT) or $msg_url, $msg_body and
     * $msg_relayState (POST).
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildArtifactMsg($http_method) {
        $rc = lasso_login_build_artifact_msg($this->_cptr, $http_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds an assertion and stores it in profile session.
     * $authenticationInstant, reauthenticateOnOrAfter, $notBefore and
     * $notOnOrAfter may be NULL.  If $authenticationInstant is NULL, the current
     * time will be used.  Time values must be encoded in UTC.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildAssertion($authenticationMethod = null, $authenticationInstant = null, $reauthenticateOnOrAfter = null, $notBefore = null, $notOnOrAfter = null) {
        $rc = lasso_login_build_assertion($this->_cptr, $authenticationMethod, $authenticationInstant, $reauthenticateOnOrAfter, $notBefore, $notOnOrAfter);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Converts profile authentication request ($request member) into a Liberty
     * message, either an URL in HTTP-Redirect profile or an URL and a field value
     * in Browser-POST (form) profile.
     * 
     * The URL is set into the $msg_url member and the eventual field value (LAREQ)
     * is set into the $msg_body member.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildAuthnRequestMsg() {
        $rc = lasso_login_build_authn_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Converts profile authentication response ($response member) into a Liberty
     * message.
     * 
     * The URL is set into the $msg_url member and the field value (LARES) is set
     * into the $msg_body member.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildAuthnResponseMsg() {
        $rc = lasso_login_build_authn_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Converts profile artifact request into a Liberty SOAP message.
     * 
     * The URL is set into the $msg_url member and the SOAP message is set into the
     * $msg_body member.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildRequestMsg() {
        $rc = lasso_login_build_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Converts profile assertion response ($response member) into a Liberty SOAP
     * messageresponse message.
     * 
     * The URL is set into the $msg_url member and the SOAP message is set into the
     * $msg_body member.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildResponseMsg($remote_providerID = null) {
        $rc = lasso_login_build_response_msg($this->_cptr, $remote_providerID);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * @return string the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_login_dump($this->_cptr);
    }

    /**
     * Initializes a new AuthnRequest from current service provider to remote
     * identity provider specified in $remote_providerID (if NULL the first known
     * identity provider is used).
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function initAuthnRequest($remote_providerID = null, $http_method = LASSO_HTTP_METHOD_REDIRECT) {
        $rc = lasso_login_init_authn_request($this->_cptr, $remote_providerID, $http_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Initializes an artifact request.  $response_msg is either the query string
     * (in redirect mode) or the form LAREQ field (in browser-post mode).
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function initRequest($response_msg, $response_http_method = LASSO_HTTP_METHOD_REDIRECT) {
        $rc = lasso_login_init_request($this->_cptr, $response_msg, $response_http_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Generates an authentication response without matching authentication
     * request.
     * 
     * If $remote_providerID is NULL, the first known provider is used.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function initIdpInitiatedAuthnRequest($remote_providerID) {
        $rc = lasso_login_init_idp_initiated_authn_request($this->_cptr, $remote_providerID);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Evaluates if consent must be asked to the Principal to federate him.
     * 
     * @return boolean TRUE if consent must be asked
     */
    public function mustAskForConsent() {
        return lasso_login_must_ask_for_consent($this->_cptr);
    }

    /**
     * Evaluates if user must be authenticated.
     * 
     * @return boolean TRUE if user must be authenticated
     */
    public function mustAuthenticate() {
        return lasso_login_must_authenticate($this->_cptr);
    }

    /**
     * Processes received authentication request, checks it is signed correctly,
     * checks if requested protocol profile is supported, etc.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processAuthnRequestMsg($authn_request_msg = null) {
        $rc = lasso_login_process_authn_request_msg($this->_cptr, $authn_request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes received authentication response.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processAuthnResponseMsg($authn_response_msg) {
        $rc = lasso_login_process_authn_response_msg($this->_cptr, $authn_response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes received artifact request.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processRequestMsg($request_msg) {
        $rc = lasso_login_process_request_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes received assertion response.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processResponseMsg($response_msg) {
        $rc = lasso_login_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * ...
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function setResourceId($content) {
        $rc = lasso_login_set_resourceId($this->_cptr, $content);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Initializes a response to the authentication request received.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function validateRequestMsg($authentication_result, $is_consent_obtained) {
        $rc = lasso_login_validate_request_msg($this->_cptr, $authentication_result, $is_consent_obtained);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    public function processPaosResponseMsg($msg) {
        $rc = lasso_login_process_paos_response_msg($this->_cptr, $msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoLoginNoInit extends LassoLogin {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLecp extends LassoLogin {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_lecp_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLecp  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoLibAuthnRequestEnvelope
     */
    protected function get_authnRequestEnvelope() {
        return cptrToPhp(LassoLecp_authnRequestEnvelope_get($this->_cptr));
    }
    protected function set_authnRequestEnvelope($value) {
        LassoLecp_authnRequestEnvelope_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return LassoLibAuthnResponseEnvelope
     */
    protected function get_authnResponseEnvelope() {
        return cptrToPhp(LassoLecp_authnResponseEnvelope_get($this->_cptr));
    }
    protected function set_authnResponseEnvelope($value) {
        LassoLecp_authnResponseEnvelope_set($this->_cptr, $value->_cptr);
    }

    /**
     * @return string
     */
    protected function get_assertionConsumerServiceURL() {
        return LassoLecp_assertionConsumerServiceURL_get($this->_cptr);
    }
    protected function set_assertionConsumerServiceURL($value) {
        LassoLecp_assertionConsumerServiceURL_set($this->_cptr, $value);
    }

    /**
     * Builds an enveloped authentication request message.  Sets $msg_body to that
     * message.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildAuthnRequestEnvelopeMsg() {
        $rc = lasso_lecp_build_authn_request_envelope_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds an authentication request. The data for the sending of the request are
     * stored in $msg_url and $msg_body (SOAP POST).
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildAuthnRequestMsg() {
        $rc = lasso_lecp_build_authn_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the lecp authentication response message (base64).  Sets $msg_body to
     * that message.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildAuthnResponseMsg() {
        $rc = lasso_lecp_build_authn_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the enveloped LECP authentication response message (SOAP message).
     * Sets $msg_body to that message.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildAuthnResponseEnvelopeMsg() {
        $rc = lasso_lecp_build_authn_response_envelope_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Initializes a new lib:AuthnRequest.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function initAuthnRequest($remote_providerID = null) {
        $rc = lasso_lecp_init_authn_request($this->_cptr, $remote_providerID);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes received authentication request, checks it is signed correctly,
     * checks if requested protocol profile is supported, etc.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processAuthnRequestMsg($authn_request_msg) {
        $rc = lasso_lecp_process_authn_request_msg($this->_cptr, $authn_request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes received enveloped authentication request, extracts the
     * authentication request out of it.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processAuthnRequestEnvelopeMsg($request_msg) {
        $rc = lasso_lecp_process_authn_request_envelope_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes received enveloped authentication response, extracts the
     * authentication response out of it and stores it in $response.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processAuthnResponseEnvelopeMsg($response_msg) {
        $rc = lasso_lecp_process_authn_response_envelope_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoLecpNoInit extends LassoLecp {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoLogout extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_logout_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoLogout  failed "); }
    }

    public static function newFromDump($server, $dump) {
        return cptrToPhp(lasso_logout_new_from_dump($server->_cptr, $dump));
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_nextProviderId() {
        return lasso_logout_get_next_providerID($this->_cptr);
    }

    /**
     * Builds the logout request message.
     * 
     * It gets the HTTP method retrieved to send the request and:
     * <itemizedlist>
     * <listitem><para>
     *   if it is a SOAP method, then it builds the logout request SOAP message,
     *   sets the msg_body attribute, gets the single logout service url and sets
     *   $msg_url in the logout object.
     * </para></listitem>
     * <listitem><para>
     *   if it is a HTTP-Redirect method, then it builds the logout request QUERY
     *   message, builds the logout request url, sets $msg_url in the logout
     *   request url, sets $msg_body to NULL.
     * </para></listitem>
     * </itemizedlist>
     * 
     * If private key and certificate are set in server object it will also signs
     * the message (either with X509 if SOAP or with a simple signature for query
     * strings).
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildRequestMsg() {
        $rc = lasso_logout_build_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the logout response message.
     * 
     * It gets the request message method and:
     * <itemizedlist>
     * <listitem><para>
     *    if it is a SOAP method, then it builds the logout response SOAP message,
     *    sets the msg_body attribute, gets the single logout service return url
     *    and sets $msg_url in the logout object.
     * </para></listitem>
     * <listitem><para>
     *    if it is a HTTP-Redirect method, then it builds the logout response QUERY message,
     *    builds the logout response url, sets $msg_url with the logout response url,
     *    sets $msg_body to NULL
     * </para></listitem>
     * </itemizedlist>
     * 
     * If private key and certificate are set in server object it will also signs
     * the message (either with X509 if SOAP or with a simple signature for query
     * strings).
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildResponseMsg() {
        $rc = lasso_logout_build_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * @return string the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_logout_dump($this->_cptr);
    }

    /**
     * Initializes a new SLO request.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function initRequest($remote_providerID = null, $request_method = LASSO_HTTP_METHOD_ANY) {
        $rc = lasso_logout_init_request($this->_cptr, $remote_providerID, $request_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a SLO LogoutRequest message.  Rebuilds a request object from the
     * message and optionally verifies its signature.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processRequestMsg($request_msg) {
        $rc = lasso_logout_process_request_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Parses the response message and builds the response object.
     * 
     * Checks the status code value and if it is not success, then if the local
     * provider is a Service Provider and response method is SOAP, then builds a
     * new logout request message for HTTP Redirect / GET method and returns the
     * error code LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE.
     * 
     * If it is a SOAP method or, IDP type and http method is Redirect/GET,
     * then removes assertion.
     * 
     * If local server is an Identity Provider and if there is no more assertion
     * (Identity Provider has logged out every Service Providers), then restores
     * the initial response.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processResponseMsg($response_msg) {
        $rc = lasso_logout_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Reset the providerID_index attribute (set to 0).
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function resetProviderIdIndex() {
        $rc = lasso_logout_reset_providerID_index($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * <itemizedlist>
     * <listitem><para>
     *   Sets the remote provider id
     * </para></listitem>
     * <listitem><para>
     *   Sets a logout response with status code value to success.
     * </para></listitem>
     * <listitem><para>
     *   Verifies federation and authentication.
     * </para></listitem>
     * <listitem><para>
     *   If the request http method is a SOAP method, then verifies every other
     *   Service Providers supports SOAP method : if not, then sets status code
     *   value to UnsupportedProfile and returns a code error with
     *   LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE.
     * </para></listitem>
     * <listitem><para>
     *   Every tests are ok, then removes assertion.
     * </para></listitem>
     * <listitem><para>
     *   If local server is an Identity Provider and if there is more than one
     *   Service Provider (except the initial Service Provider), then saves the
     *   initial request, response and remote provider id.
     * </para></listitem>
     * </itemizedlist>
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function validateRequest() {
        $rc = lasso_logout_validate_request($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoLogoutNoInit extends LassoLogout {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoNameIdentifierMapping extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_name_identifier_mapping_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoNameIdentifierMapping  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_targetNameIdentifier() {
        return LassoNameIdentifierMapping_targetNameIdentifier_get($this->_cptr);
    }
    protected function set_targetNameIdentifier($value) {
        LassoNameIdentifierMapping_targetNameIdentifier_set($this->_cptr, $value);
    }

    /**
     * Builds a name identifier mapping request message.
     * 
     * <itemizedlist>
     * <listitem><para>
     *   If it is a SOAP method, then it builds the request as a SOAP message,
     *   optionally signs his node, sets $msg_body with that message and sets
     *   $msg_url with the SOAP Endpoint URL
     * </para></listitem>
     * <listitem><para>
     *   If it is a HTTP-Redirect method, then it builds the request as a query
     *   string message, optionally signs it and sets $msg_url to that URL.
     * </para></listitem>
     * </itemizedlist>
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildRequestMsg() {
        $rc = lasso_name_identifier_mapping_build_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds a name identifier mapping response message.
     * 
     * <itemizedlist>
     * <listitem><para>
     *   If it is a SOAP method, then it builds the response as a SOAP message,
     *   optionally signs his node, sets $msg_body with that message and sets
     *   $msg_url with the register name identifier service return URL.
     * </para></listitem>
     * <listitem><para>
     *   If it is a HTTP-Redirect method, then it builds the response as a query
     *   string message, optionally signs it and sets $msg_url to that URL.
     * </para></listitem>
     * </itemizedlist>
     * 
     * If private key and certificate are set in server object it will also signs
     * the message (either with X509 if SOAP or with a simple signature for query
     * strings).
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildResponseMsg() {
        $rc = lasso_name_identifier_mapping_build_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Initializes a new lib:NameIdentifierMappingRequest request.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function initRequest($targetNamespace, $remote_providerID = null) {
        $rc = lasso_name_identifier_mapping_init_request($this->_cptr, $targetNamespace, $remote_providerID);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a lib:NameIdentifierMappingRequest message.  Rebuilds a request
     * object from the message and optionally verifies its signature.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processRequestMsg($request_msg) {
        $rc = lasso_name_identifier_mapping_process_request_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a lib:NameIdentifierMappingResponse message.  Rebuilds a response
     * object from the message and optionally verifies its signature.
     * 
     * If the response depicts Success it will also sets $targetNameIdentifier.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processResponseMsg($response_msg) {
        $rc = lasso_name_identifier_mapping_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Checks profile request with regards to message status and principal
     * federations, update them accordingly and prepares a 
     * lib:NameIdentifierMappingResponse accordingly.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function validateRequest() {
        $rc = lasso_name_identifier_mapping_validate_request($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoNameIdentifierMappingNoInit extends LassoNameIdentifierMapping {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoNameRegistration extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_name_registration_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoNameRegistration  failed "); }
    }

    public static function newFromDump($server, $dump) {
        return cptrToPhp(lasso_name_registration_new_from_dump($server->_cptr, $dump));
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return LassoSamlNameIdentifier
     */
    protected function get_oldNameIdentifier() {
        return cptrToPhp(LassoNameRegistration_oldNameIdentifier_get($this->_cptr));
    }
    protected function set_oldNameIdentifier($value) {
        LassoNameRegistration_oldNameIdentifier_set($this->_cptr, $value->_cptr);
    }

    /**
     * Builds a register name identifier request message.
     * 
     * It gets the register name identifier protocol profile and:
     * <itemizedlist>
     * <listitem><para>
     *   if it is a SOAP method, then it builds the register name identifier
     *   request SOAP message, optionally signs his node, sets $msg_body,
     *   gets the SoapEndpoint url and sets $msg_url.
     * </para></listitem>
     * <listitem><para>
     *   if it is a HTTP-Redirect method, then it builds the register name
     *   identifier request QUERY message (optionally signs the request message),
     *   builds the request url with register name identifier url with register
     *   name identifier service url, sets $msg_url in the register name
     *   identifier object, sets $msg_body to NULL.
     * </para></listitem>
     * </itemizedlist>
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildRequestMsg() {
        $rc = lasso_name_registration_build_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the register name idendifier response message.
     * 
     * It gets the request message method and:
     * <itemizedlist>
     * <listitem><para>
     *    if it is a SOAP method, then it builds the response SOAP message, sets
     *    the msg_body attribute, gets the register name identifier service return
     *    url and sets $msg_url of the object.
     * </para></listitem>
     * <listitem><para>
     *    if it is a HTTP-Redirect method, then it builds the response QUERY
     *    message, builds the response url, sets $msg_url with the response url
     *    and sets the msg_body with NULL
     * </para></listitem>
     * </itemizedlist>
     * 
     * If private key and certificate are set in server object it will also signs
     * the message (either with X509 if SOAP or with a simple signature for query
     * strings).
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildResponseMsg() {
        $rc = lasso_name_registration_build_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * @return string the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_name_registration_dump($this->_cptr);
    }

    /**
     * Initializes a new lib:RegisterNameIdentifierRequest request; it sets
     * $this->nameIdentifier to the new name identifier and
     * $this->oldNameIdentifier to the old one.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function initRequest($remote_providerID, $http_method = LASSO_HTTP_METHOD_ANY) {
        $rc = lasso_name_registration_init_request($this->_cptr, $remote_providerID, $http_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a lib:RegisterNameIdentifierRequest message.  Rebuilds a request
     * object from the message and optionally verifies its signature.  Sets
     * profile->nameIdentifier to local name identifier.  If it changed (when this
     * is IdP-initiated and there was no previously defined local name identifier)
     * profile->nameIdentifier will be the new one and profile->oldNameIdentiifer
     * the old one.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processRequestMsg($request_msg) {
        $rc = lasso_name_registration_process_request_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a lib:RegisterNameIdentifierResponse message.  Rebuilds a response
     * object from the message and optionally verifies its signature.
     * 
     * If the response depicts Success it will also update Principal federation.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processResponseMsg($response_msg) {
        $rc = lasso_name_registration_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Checks profile request with regards to message status and principal
     * federations, update them accordingly and prepares a 
     * lib:RegisterNameIdentifierResponse accordingly.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function validateRequest() {
        $rc = lasso_name_registration_validate_request($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoNameRegistrationNoInit extends LassoNameRegistration {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoProvider extends LassoNode {
    public $_cptr = null;

    public function __construct($role, $metadata, $public_key = null, $ca_cert_chain = null) {
        $this->_cptr = lasso_provider_new($role, $metadata, $public_key, $ca_cert_chain);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoProvider  failed "); }
    }

    public static function newFromDump($dump) {
        return cptrToPhp(lasso_provider_new_from_dump($dump));
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_providerId() {
        return LassoProvider_providerId_get($this->_cptr);
    }
    protected function set_providerId($value) {
        LassoProvider_providerId_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_role() {
        return LassoProvider_role_get($this->_cptr);
    }
    protected function set_role($value) {
        LassoProvider_role_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_metadataFilename() {
        return LassoProvider_metadataFilename_get($this->_cptr);
    }
    protected function set_metadataFilename($value) {
        LassoProvider_metadataFilename_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_publicKey() {
        return LassoProvider_publicKey_get($this->_cptr);
    }
    protected function set_publicKey($value) {
        LassoProvider_publicKey_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_caCertChain() {
        return LassoProvider_caCertChain_get($this->_cptr);
    }
    protected function set_caCertChain($value) {
        LassoProvider_caCertChain_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_base64SuccinctId() {
        return lasso_provider_get_base64_succinct_id($this->_cptr);
    }

    /**
     * @return string
     */
    protected function get_organization() {
        return lasso_provider_get_organization($this->_cptr);
    }

    /**
     * @return int
     */
    protected function get_protocolConformance() {
        return lasso_provider_get_protocol_conformance($this->_cptr);
    }

    /**
     * Extracts the AssertionConsumerServiceURL from the provider metadata
     * descriptor.
     * 
     * @return string the element value, NULL if the element was not found.  This
     *      string must be freed by the caller.
     */
    public function getAssertionConsumerServiceUrl($service_id) {
        return lasso_provider_get_assertion_consumer_service_url($this->_cptr, $service_id);
    }

    /**
     * Extracts the element $name from the provider metadata descriptor.
     * 
     * @return string the element value, NULL if the element was not found.  This
     *      string must be freed by the caller.
     */
    public function getMetadataOne($name) {
        return lasso_provider_get_metadata_one($this->_cptr, $name);
    }

    /**
     * Extracts zero to many elements from the provider metadata descriptor.
     * 
     * @return array a GList with the elements.  This GList is internally
     *      allocated and points to internally allocated strings.  It must
     *      not be freed, modified or stored.
     */
    public function getMetadataList($name) {
        return lasso_provider_get_metadata_list($this->_cptr, $name);
    }

    /**
     * Looks up and returns a LassoHttpMethod appropriate for performing the
     * $protocol_type between $this and $remote_provider.
     * 
     * @return int the LassoHttpMethod
     */
    public function getFirstHttpMethod($remote_provider, $protocol_type) {
        return lasso_provider_get_first_http_method($this->_cptr, $remote_provider._cptr, $protocol_type);
    }

    /**
     * Gets if $http_method is an appropriate method for the $protocol_type profile
     * between $this and $remote_provider.
     * 
     * @return boolean TRUE if it is appropriate
     */
    public function acceptHttpMethod($remote_provider, $protocol_type, $http_method, $initiate_profile) {
        return lasso_provider_accept_http_method($this->_cptr, $remote_provider._cptr, $protocol_type, $http_method, $initiate_profile);
    }

    /**
     * Gets if $this supports $protocol_profile.
     * 
     * @return boolean TRUE if it is supported
     */
    public function hasProtocolProfile($protocol_type, $protocol_profile) {
        return lasso_provider_has_protocol_profile($this->_cptr, $protocol_type, $protocol_profile);
    }

    /**
     * Activate or desactivate encryption
     */
    public function setEncryptionMode($encryption_mode) {
        return lasso_provider_set_encryption_mode($this->_cptr, $encryption_mode);
    }

    /**
     * Set the type of the generated encryption symetric key
     */
    public function setEncryptionSymKeyType($encryption_sym_key_type) {
        return lasso_provider_set_encryption_sym_key_type($this->_cptr, $encryption_sym_key_type);
    }


}

/**
 * @package Lasso
 */
class LassoProviderNoInit extends LassoProvider {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoServer extends LassoProvider {
    public $_cptr = null;

    public function __construct($metadata = null, $private_key = null, $private_key_password = null, $certificate = null) {
        $this->_cptr = lasso_server_new($metadata, $private_key, $private_key_password, $certificate);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoServer  failed "); }
    }

    public static function newFromDump($dump) {
        return cptrToPhp(lasso_server_new_from_dump($dump));
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_providers() {
        $array = LassoServer_providers_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $key => $item) {
            $obj_array[$key] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_providers($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        LassoServer_providers_set($this->_cptr, $array);
    }

    /**
     * @return array
     */
    protected function get_services() {
        $array = LassoServer_services_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $key => $item) {
            $obj_array[$key] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_services($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        LassoServer_services_set($this->_cptr, $array);
    }

    /**
     * @return string
     */
    protected function get_privateKey() {
        return LassoServer_privateKey_get($this->_cptr);
    }
    protected function set_privateKey($value) {
        LassoServer_privateKey_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_privateKeyPassword() {
        return LassoServer_privateKeyPassword_get($this->_cptr);
    }
    protected function set_privateKeyPassword($value) {
        LassoServer_privateKeyPassword_set($this->_cptr, $value);
    }

    /**
     * @return string
     */
    protected function get_certificate() {
        return LassoServer_certificate_get($this->_cptr);
    }
    protected function set_certificate($value) {
        LassoServer_certificate_set($this->_cptr, $value);
    }

    /**
     * @return int
     */
    protected function get_signatureMethod() {
        return LassoServer_signatureMethod_get($this->_cptr);
    }
    protected function set_signatureMethod($value) {
        LassoServer_signatureMethod_set($this->_cptr, $value);
    }

    /**
     * Creates a new LassoProvider and makes it known to the $this
     * 
     * @return int 0 on success; a negative value if an error occured.
     */
    public function addProvider($role, $metadata, $public_key = null, $ca_cert_chain = null) {
        $rc = lasso_server_add_provider($this->_cptr, $role, $metadata, $public_key, $ca_cert_chain);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * ...
     * 
     * @return int 0 on success; a negative value if an error occured.
     */
    public function addService($service) {
        $rc = lasso_server_add_service($this->_cptr, $service._cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    public function addServiceFromDump($dump) {
        $rc = lasso_server_add_service_from_dump($this->_cptr, $dump);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * @return string the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_server_dump($this->_cptr);
    }

    /**
     * Looks up for a LassoProvider whose ID is $providerID and returns it.
     * 
     * @return LassoProvider the LassoProvider, NULL if it was not found.  The
     *     LassoProvider is owned by Lasso and should not be freed.
     */
    public function getProvider($providerID) {
        return lasso_server_get_provider($this->_cptr, $providerID);
    }

    /**
     * Load an encryption private key from a file and set it in the server object
     * 
     * @return int 0 on success; another value if an error occured.
     */
    public function setEncryptionPrivateKey($filename) {
        $rc = lasso_server_set_encryption_private_key($this->_cptr, $filename);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Load an affiliation metadata file into $this; this must be called after
     * providers have been added to $this.
     * 
     * @return int 0 on success; another value if an error occured.
     */
    public function loadAffiliation($filename) {
        $rc = lasso_server_load_affiliation($this->_cptr, $filename);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoServerNoInit extends LassoServer {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoSession extends LassoNode {
    public $_cptr = null;

    public function __construct() {
        $this->_cptr = lasso_session_new();
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoSession  failed "); }
    }

    public static function newFromDump($dump) {
        return cptrToPhp(lasso_session_new_from_dump($dump));
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return array
     */
    protected function get_assertions() {
        $array = LassoSession_assertions_get($this->_cptr);
        $obj_array = array();
        foreach ($array as $key => $item) {
            $obj_array[$key] = cptrToPhp($item);
        }
        $array = $obj_array;
        return $array;
    }
    protected function set_assertions($value) {
        $array = array();
        if (!is_null($value)) {
            foreach ($value as $key => $item) {
                $array[$key] = $item->_cptr;
            }
        }
        LassoSession_assertions_set($this->_cptr, $array);
    }

    /**
     * @return boolean
     */
    protected function get_isDirty() {
        return LassoSession_isDirty_get($this->_cptr);
    }
    protected function set_isDirty($value) {
        LassoSession_isDirty_set($this->_cptr, $value);
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * @return string the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_session_dump($this->_cptr);
    }

    /**
     * Gets the assertions for the given $provider_id.
     * 
     * @return array a GList* of LassoSamlAssertion.  Caller must free the GList
     *     but NOT the assertions it contains.
     */
    public function getAssertions($provider_id = null) {
        return lasso_session_get_assertions($this->_cptr, $provider_id);
    }

    /**
     * Looks up and returns the nth provider id.
     * 
     * @return string the provider id; or NULL if there were no nth provider.  This
     *      string must be freed by the caller.
     */
    public function getProviderIndex($index) {
        return lasso_session_get_provider_index($this->_cptr, $index);
    }

    /**
     * Returns TRUE if session is empty.
     * 
     * @return boolean TRUE if empty
     */
    public function isEmpty() {
        return lasso_session_is_empty($this->_cptr);
    }


}

/**
 * @package Lasso
 */
class LassoSessionNoInit extends LassoSession {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoAssertionQuery extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_assertion_query_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoAssertionQuery  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * Initializes a new Assertion Query Request.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function initRequest($remote_provider_id, $http_method, $query_request_type) {
        $rc = lasso_assertion_query_init_request($this->_cptr, $remote_provider_id, $http_method, $query_request_type);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a Assertion query or request; caller must add assertions to the
     * response afterwards.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function validateRequest() {
        $rc = lasso_assertion_query_validate_request($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the Name Id Management request message.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildRequestMsg() {
        $rc = lasso_assertion_query_build_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a Assertion query or request message.  Rebuilds a request object
     * from the message and check its signature.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processRequestMsg($request_msg) {
        $rc = lasso_assertion_query_process_request_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the Response message.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildResponseMsg() {
        $rc = lasso_assertion_query_build_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Parses the response message and builds the corresponding response object.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processResponseMsg($response_msg) {
        $rc = lasso_assertion_query_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoAssertionQueryNoInit extends LassoAssertionQuery {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoEcp extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_ecp_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoEcp  failed "); }
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * @return string
     */
    protected function get_assertionConsumerURL() {
        return LassoEcp_assertionConsumerURL_get($this->_cptr);
    }
    protected function set_assertionConsumerURL($value) {
        LassoEcp_assertionConsumerURL_set($this->_cptr, $value);
    }

    public function processAuthnRequestMsg($authn_request_msg) {
        $rc = lasso_ecp_process_authn_request_msg($this->_cptr, $authn_request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    public function processResponseMsg($response_msg) {
        $rc = lasso_ecp_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoEcpNoInit extends LassoEcp {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoNameIdManagement extends LassoProfile {
    public $_cptr = null;

    public function __construct($server) {
        $this->_cptr = lasso_name_id_management_new($server->_cptr);
        if (is_null($this->_cptr)) { throw new Exception("Constructor for  LassoNameIdManagement  failed "); }
    }

    public static function newFromDump($server, $dump) {
        return cptrToPhp(lasso_name_id_management_new_from_dump($server->_cptr, $dump));
    }

    /**
     * @return mixed
     */
    public function __get($attr) {
        $func = "get_" . $attr;
        if (method_exists($this, $func)) {
            return call_user_func(array($this, $func));
        }
        return null;
    }

    public function __set($attr, $value) {
        $func = "set_" . $attr;
        if (method_exists($this, $func)) {
            call_user_func(array($this, $func), $value);
        }
    }

    /**
     * Dumps $this content to an XML string.
     * 
     * @return string the dump string.  It must be freed by the caller.
     */
    public function dump() {
        return lasso_name_id_management_dump($this->_cptr);
    }

    /**
     * Initializes a new Name Id Management Request.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function initRequest($remote_provider_id = null, $new_name_id = null, $http_method = LASSO_HTTP_METHOD_ANY) {
        $rc = lasso_name_id_management_init_request($this->_cptr, $remote_provider_id, $new_name_id, $http_method);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the Name Id Management request message.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildRequestMsg() {
        $rc = lasso_name_id_management_build_request_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a Name Id Management request message.  Rebuilds a request object
     * from the message and check its signature.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processRequestMsg($request_msg) {
        $rc = lasso_name_id_management_process_request_msg($this->_cptr, $request_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Processes a Name Id Management request, performing requested actions against
     * principal federations.  Profile identity may have to be saved afterwards.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function validateRequest() {
        $rc = lasso_name_id_management_validate_request($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Builds the Name Id Management response message.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function buildResponseMsg() {
        $rc = lasso_name_id_management_build_response_msg($this->_cptr);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }

    /**
     * Parses the response message and builds the corresponding response object.
     * Performs requested actions against principal federations.  Profile identity
     * may have to be saved afterwards.
     * 
     * @return int 0 on success; or a negative value otherwise.
     */
    public function processResponseMsg($response_msg) {
        $rc = lasso_name_id_management_process_response_msg($this->_cptr, $response_msg);
        if ($rc == 0) {
            return 0;
        } else if ($rc > 0) {
            return $rc;
        } else if ($rc < 0) {
            LassoError::throw_on_rc($rc);
        }
    }


}

/**
 * @package Lasso
 */
class LassoNameIdManagementNoInit extends LassoNameIdManagement {
    public function __construct() {}
}

/**
 * @package Lasso
 */
class LassoProfileError extends LassoError {}

/**
 * @package Lasso
 */
class LassoProviderError extends LassoError {}

/**
 * @package Lasso
 */
class LassoServerError extends LassoProviderError {}

/**
 * @package Lasso
 */
class LassoLoginError extends LassoProfileError {}

/**
 * @package Lasso
 */
class LassoLogoutError extends LassoProfileError {}

/**
 * @package Lasso
 */
class LassoDefederationError extends LassoProfileError {}

/**
 * @package Lasso
 */
class LassoNameIdentifierMappingError extends LassoProfileError {}

/**
 * @package Lasso
 */
class LassoWsfProfileError extends LassoProfileError {}

/**
 * @package Lasso
 */
class LassoDiscoveryError extends LassoWsfProfileError {}

/**
 * @package Lasso
 */
class LassoDataServiceError extends LassoWsfProfileError {}

/**
 * @package Lasso
 */
class LassoDstError extends LassoWsfProfileError {}

/**
 * @package Lasso
 */
class LassoXmlError extends LassoError {}

/**
 * @package Lasso
 */
class LassoXmlNodeNotFoundError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_NODE_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoXmlNodeContentNotFoundError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_NODE_CONTENT_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoXmlAttrNotFoundError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_ATTR_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoXmlAttrValueNotFoundError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_ATTR_VALUE_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoXmlInvalidFileError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_INVALID_FILE;
}

/**
 * @package Lasso
 */
class LassoXmlObjectConstructionFailedError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_OBJECT_CONSTRUCTION_FAILED;
}

/**
 * @package Lasso
 */
class LassoXmlMissingNamespaceError extends LassoXmlError {
    protected $code = LASSO_XML_ERROR_MISSING_NAMESPACE;
}

/**
 * @package Lasso
 */
class LassoDsError extends LassoError {}

/**
 * @package Lasso
 */
class LassoDsSignatureNotFoundError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_SIGNATURE_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoDsInvalidSignatureError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_INVALID_SIGNATURE;
}

/**
 * @package Lasso
 */
class LassoDsSignatureTmplCreationFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_SIGNATURE_TMPL_CREATION_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsContextCreationFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_CONTEXT_CREATION_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsPublicKeyLoadFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_PUBLIC_KEY_LOAD_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsPrivateKeyLoadFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_PRIVATE_KEY_LOAD_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsCertificateLoadFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_CERTIFICATE_LOAD_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsSignatureFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_SIGNATURE_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsKeysMngrCreationFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_KEYS_MNGR_CREATION_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsKeysMngrInitFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_KEYS_MNGR_INIT_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsSignatureVerificationFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_SIGNATURE_VERIFICATION_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsCaCertChainLoadFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_CA_CERT_CHAIN_LOAD_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsInvalidSigalgError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_INVALID_SIGALG;
}

/**
 * @package Lasso
 */
class LassoDsDigestComputeFailedError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_DIGEST_COMPUTE_FAILED;
}

/**
 * @package Lasso
 */
class LassoDsSignatureTemplateNotFoundError extends LassoDsError {
    protected $code = LASSO_DS_ERROR_SIGNATURE_TEMPLATE_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoServerProviderNotFoundError extends LassoServerError {
    protected $code = LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoServerAddProviderFailedError extends LassoServerError {
    protected $code = LASSO_SERVER_ERROR_ADD_PROVIDER_FAILED;
}

/**
 * @package Lasso
 */
class LassoServerAddProviderProtocolMismatchError extends LassoServerError {
    protected $code = LASSO_SERVER_ERROR_ADD_PROVIDER_PROTOCOL_MISMATCH;
}

/**
 * @package Lasso
 */
class LassoServerSetEncryptionPrivateKeyFailedError extends LassoServerError {
    protected $code = LASSO_SERVER_ERROR_SET_ENCRYPTION_PRIVATE_KEY_FAILED;
}

/**
 * @package Lasso
 */
class LassoServerInvalidXmlError extends LassoServerError {
    protected $code = LASSO_SERVER_ERROR_INVALID_XML;
}

/**
 * @package Lasso
 */
class LassoLogoutUnsupportedProfileError extends LassoLogoutError {
    protected $code = LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE;
}

/**
 * @package Lasso
 */
class LassoLogoutRequestDeniedError extends LassoLogoutError {
    protected $code = LASSO_LOGOUT_ERROR_REQUEST_DENIED;
}

/**
 * @package Lasso
 */
class LassoLogoutFederationNotFoundError extends LassoLogoutError {
    protected $code = LASSO_LOGOUT_ERROR_FEDERATION_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoLogoutUnknownPrincipalError extends LassoLogoutError {
    protected $code = LASSO_LOGOUT_ERROR_UNKNOWN_PRINCIPAL;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidQueryError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_QUERY;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidPostMsgError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_POST_MSG;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidSoapMsgError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_SOAP_MSG;
}

/**
 * @package Lasso
 */
class LassoProfileMissingRequestError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_REQUEST;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidHttpMethodError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_HTTP_METHOD;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidProtocolprofileError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_PROTOCOLPROFILE;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidMsgError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_MSG;
}

/**
 * @package Lasso
 */
class LassoProfileMissingRemoteProvideridError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_REMOTE_PROVIDERID;
}

/**
 * @package Lasso
 */
class LassoProfileUnsupportedProfileError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_UNSUPPORTED_PROFILE;
}

/**
 * @package Lasso
 */
class LassoProfileUnknownProfileUrlError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_UNKNOWN_PROFILE_URL;
}

/**
 * @package Lasso
 */
class LassoProfileIdentityNotFoundError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_IDENTITY_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoProfileFederationNotFoundError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_FEDERATION_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoProfileNameIdentifierNotFoundError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoProfileBuildingQueryFailedError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_BUILDING_QUERY_FAILED;
}

/**
 * @package Lasso
 */
class LassoProfileBuildingRequestFailedError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_BUILDING_REQUEST_FAILED;
}

/**
 * @package Lasso
 */
class LassoProfileBuildingMessageFailedError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_BUILDING_MESSAGE_FAILED;
}

/**
 * @package Lasso
 */
class LassoProfileBuildingResponseFailedError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_BUILDING_RESPONSE_FAILED;
}

/**
 * @package Lasso
 */
class LassoProfileSessionNotFoundError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_SESSION_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoProfileBadIdentityDumpError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_BAD_IDENTITY_DUMP;
}

/**
 * @package Lasso
 */
class LassoProfileBadSessionDumpError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_BAD_SESSION_DUMP;
}

/**
 * @package Lasso
 */
class LassoProfileMissingResponseError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_RESPONSE;
}

/**
 * @package Lasso
 */
class LassoProfileMissingStatusCodeError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_STATUS_CODE;
}

/**
 * @package Lasso
 */
class LassoProfileMissingArtifactError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_ARTIFACT;
}

/**
 * @package Lasso
 */
class LassoProfileMissingResourceOfferingError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_RESOURCE_OFFERING;
}

/**
 * @package Lasso
 */
class LassoProfileMissingServiceDescriptionError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_SERVICE_DESCRIPTION;
}

/**
 * @package Lasso
 */
class LassoProfileMissingServiceTypeError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_SERVICE_TYPE;
}

/**
 * @package Lasso
 */
class LassoProfileMissingAssertionError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_ASSERTION;
}

/**
 * @package Lasso
 */
class LassoProfileMissingSubjectError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_SUBJECT;
}

/**
 * @package Lasso
 */
class LassoProfileMissingNameIdentifierError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_NAME_IDENTIFIER;
}

/**
 * @package Lasso
 */
class LassoProfileInvalidArtifactError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_INVALID_ARTIFACT;
}

/**
 * @package Lasso
 */
class LassoProfileMissingEncryptionPrivateKeyError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_ENCRYPTION_PRIVATE_KEY;
}

/**
 * @package Lasso
 */
class LassoProfileStatusNotSuccessError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_STATUS_NOT_SUCCESS;
}

/**
 * @package Lasso
 */
class LassoProfileMissingIssuerError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_ISSUER;
}

/**
 * @package Lasso
 */
class LassoProfileMissingServiceInstanceError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_SERVICE_INSTANCE;
}

/**
 * @package Lasso
 */
class LassoProfileMissingEndpointReferenceError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE;
}

/**
 * @package Lasso
 */
class LassoProfileMissingEndpointReferenceAddressError extends LassoProfileError {
    protected $code = LASSO_PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE_ADDRESS;
}

/**
 * @package Lasso
 */
class LassoParamError extends LassoError {}

/**
 * @package Lasso
 */
class LassoParamBadTypeOrNullObjError extends LassoParamError {
    protected $code = LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ;
}

/**
 * @package Lasso
 */
class LassoParamInvalidValueError extends LassoParamError {
    protected $code = LASSO_PARAM_ERROR_INVALID_VALUE;
}

/**
 * @package Lasso
 */
class LassoParamCheckFailedError extends LassoParamError {
    protected $code = LASSO_PARAM_ERROR_CHECK_FAILED;
}

/**
 * @package Lasso
 */
class LassoParamNonInitializedObjectError extends LassoParamError {
    protected $code = LASSO_PARAM_ERROR_NON_INITIALIZED_OBJECT;
}

/**
 * @package Lasso
 */
class LassoLoginFederationNotFoundError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_FEDERATION_NOT_FOUND;
}

/**
 * @package Lasso
 */
class LassoLoginConsentNotObtainedError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_CONSENT_NOT_OBTAINED;
}

/**
 * @package Lasso
 */
class LassoLoginInvalidNameidpolicyError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_INVALID_NAMEIDPOLICY;
}

/**
 * @package Lasso
 */
class LassoLoginRequestDeniedError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_REQUEST_DENIED;
}

/**
 * @package Lasso
 */
class LassoLoginInvalidSignatureError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_INVALID_SIGNATURE;
}

/**
 * @package Lasso
 */
class LassoLoginUnsignedAuthnRequestError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_UNSIGNED_AUTHN_REQUEST;
}

/**
 * @package Lasso
 */
class LassoLoginStatusNotSuccessError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_STATUS_NOT_SUCCESS;
}

/**
 * @package Lasso
 */
class LassoLoginUnknownPrincipalError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_UNKNOWN_PRINCIPAL;
}

/**
 * @package Lasso
 */
class LassoLoginNoDefaultEndpointError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_NO_DEFAULT_ENDPOINT;
}

/**
 * @package Lasso
 */
class LassoLoginAssertionReplayError extends LassoLoginError {
    protected $code = LASSO_LOGIN_ERROR_ASSERTION_REPLAY;
}

/**
 * @package Lasso
 */
class LassoDefederationMissingNameIdentifierError extends LassoDefederationError {
    protected $code = LASSO_DEFEDERATION_ERROR_MISSING_NAME_IDENTIFIER;
}

/**
 * @package Lasso
 */
class LassoSoapError extends LassoError {}

/**
 * @package Lasso
 */
class LassoSoapMissingEnvelopeError extends LassoSoapError {
    protected $code = LASSO_SOAP_ERROR_MISSING_ENVELOPE;
}

/**
 * @package Lasso
 */
class LassoSoapMissingHeaderError extends LassoSoapError {
    protected $code = LASSO_SOAP_ERROR_MISSING_HEADER;
}

/**
 * @package Lasso
 */
class LassoSoapMissingBodyError extends LassoSoapError {
    protected $code = LASSO_SOAP_ERROR_MISSING_BODY;
}

/**
 * @package Lasso
 */
class LassoSoapMissingSoapFaultDetailError extends LassoSoapError {
    protected $code = LASSO_SOAP_ERROR_MISSING_SOAP_FAULT_DETAIL;
}

/**
 * @package Lasso
 */
class LassoNameidentifiermappingMissingTargetNamespaceError extends LassoNameIdentifierMappingError {
    protected $code = LASSO_NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_NAMESPACE;
}

/**
 * @package Lasso
 */
class LassoNameidentifiermappingForbiddenCallOnThisSideError extends LassoNameIdentifierMappingError {
    protected $code = LASSO_NAME_IDENTIFIER_MAPPING_ERROR_FORBIDDEN_CALL_ON_THIS_SIDE;
}

/**
 * @package Lasso
 */
class LassoNameidentifiermappingMissingTargetIdentifierError extends LassoNameIdentifierMappingError {
    protected $code = LASSO_NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_IDENTIFIER;
}

/**
 * @package Lasso
 */
class LassoDataserviceUnregisteredDstError extends LassoDataServiceError {
    protected $code = LASSO_DATA_SERVICE_ERROR_UNREGISTERED_DST;
}

/**
 * @package Lasso
 */
class LassoWsfprofileMissingCorrelationError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_MISSING_CORRELATION;
}

/**
 * @package Lasso
 */
class LassoWsfprofileMissingSecurityError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_MISSING_SECURITY;
}

/**
 * @package Lasso
 */
class LassoWsfprofileMissingAssertionIdError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_MISSING_ASSERTION_ID;
}

/**
 * @package Lasso
 */
class LassoWsfprofileMissingEndpointError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_MISSING_ENDPOINT;
}

/**
 * @package Lasso
 */
class LassoWsfprofileSoapFaultError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_SOAP_FAULT;
}

/**
 * @package Lasso
 */
class LassoWsfprofileUnsupportedSecurityMechanismError extends LassoWsfProfileError {
    protected $code = LASSO_WSF_PROFILE_ERROR_UNSUPPORTED_SECURITY_MECHANISM;
}

/**
 * @package Lasso
 */
class LassoDiscoverySvcMetadataRegisterFailedError extends LassoDiscoveryError {
    protected $code = LASSO_DISCOVERY_ERROR_SVC_METADATA_REGISTER_FAILED;
}

/**
 * @package Lasso
 */
class LassoDiscoverySvcMetadataAssociationAddFailedError extends LassoDiscoveryError {
    protected $code = LASSO_DISCOVERY_ERROR_SVC_METADATA_ASSOCIATION_ADD_FAILED;
}

/**
 * @package Lasso
 */
class LassoDiscoveryMissingRequestedServiceError extends LassoDiscoveryError {
    protected $code = LASSO_DISCOVERY_ERROR_MISSING_REQUESTED_SERVICE;
}

/**
 * @package Lasso
 */
class LassoDiscoveryFailedToBuildEndpointReferenceError extends LassoDiscoveryError {
    protected $code = LASSO_DISCOVERY_ERROR_FAILED_TO_BUILD_ENDPOINT_REFERENCE;
}

/**
 * @package Lasso
 */
class LassoDstMissingServiceDataError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_MISSING_SERVICE_DATA;
}

/**
 * @package Lasso
 */
class LassoDstQueryFailedError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_QUERY_FAILED;
}

/**
 * @package Lasso
 */
class LassoDstQueryPartiallyFailedError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_QUERY_PARTIALLY_FAILED;
}

/**
 * @package Lasso
 */
class LassoDstModifyFailedError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_MODIFY_FAILED;
}

/**
 * @package Lasso
 */
class LassoDstModifyPartiallyFailedError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_MODIFY_PARTIALLY_FAILED;
}

/**
 * @package Lasso
 */
class LassoDstNewDataMissingError extends LassoDstError {
    protected $code = LASSO_DST_ERROR_NEW_DATA_MISSING;
}

/**
 * @package Lasso
 */
class LassoError extends Exception {
    private static $exceptions_dict = array(
        LASSO_PROFILE_ERROR_SESSION_NOT_FOUND => "LassoProfileSessionNotFoundError",
        LASSO_WSF_PROFILE_ERROR_MISSING_ENDPOINT => "LassoWsfprofileMissingEndpointError",
        LASSO_LOGIN_ERROR_ASSERTION_REPLAY => "LassoLoginAssertionReplayError",
        LASSO_DISCOVERY_ERROR_SVC_METADATA_REGISTER_FAILED => "LassoDiscoverySvcMetadataRegisterFailedError",
        LASSO_DS_ERROR_DIGEST_COMPUTE_FAILED => "LassoDsDigestComputeFailedError",
        LASSO_NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_NAMESPACE => "LassoNameidentifiermappingMissingTargetNamespaceError",
        LASSO_DS_ERROR_SIGNATURE_NOT_FOUND => "LassoDsSignatureNotFoundError",
        LASSO_LOGIN_ERROR_FEDERATION_NOT_FOUND => "LassoLoginFederationNotFoundError",
        LASSO_DST_ERROR_QUERY_PARTIALLY_FAILED => "LassoDstQueryPartiallyFailedError",
        LASSO_DS_ERROR_SIGNATURE_FAILED => "LassoDsSignatureFailedError",
        LASSO_DS_ERROR_CERTIFICATE_LOAD_FAILED => "LassoDsCertificateLoadFailedError",
        LASSO_DST_ERROR_MODIFY_FAILED => "LassoDstModifyFailedError",
        LASSO_DS_ERROR_INVALID_SIGALG => "LassoDsInvalidSigalgError",
        LASSO_DS_ERROR_KEYS_MNGR_INIT_FAILED => "LassoDsKeysMngrInitFailedError",
        LASSO_DST_ERROR_MISSING_SERVICE_DATA => "LassoDstMissingServiceDataError",
        LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE => "LassoLogoutUnsupportedProfileError",
        LASSO_PROFILE_ERROR_BUILDING_QUERY_FAILED => "LassoProfileBuildingQueryFailedError",
        LASSO_LOGOUT_ERROR_UNKNOWN_PRINCIPAL => "LassoLogoutUnknownPrincipalError",
        LASSO_PROFILE_ERROR_INVALID_PROTOCOLPROFILE => "LassoProfileInvalidProtocolprofileError",
        LASSO_DS_ERROR_SIGNATURE_TEMPLATE_NOT_FOUND => "LassoDsSignatureTemplateNotFoundError",
        LASSO_LOGIN_ERROR_INVALID_NAMEIDPOLICY => "LassoLoginInvalidNameidpolicyError",
        LASSO_DS_ERROR_INVALID_SIGNATURE => "LassoDsInvalidSignatureError",
        LASSO_PROFILE_ERROR_STATUS_NOT_SUCCESS => "LassoProfileStatusNotSuccessError",
        LASSO_DS_ERROR_PRIVATE_KEY_LOAD_FAILED => "LassoDsPrivateKeyLoadFailedError",
        LASSO_PROFILE_ERROR_FEDERATION_NOT_FOUND => "LassoProfileFederationNotFoundError",
        LASSO_SERVER_ERROR_PROVIDER_NOT_FOUND => "LassoServerProviderNotFoundError",
        LASSO_DST_ERROR_MODIFY_PARTIALLY_FAILED => "LassoDstModifyPartiallyFailedError",
        LASSO_SOAP_ERROR_MISSING_SOAP_FAULT_DETAIL => "LassoSoapMissingSoapFaultDetailError",
        LASSO_XML_ERROR_ATTR_NOT_FOUND => "LassoXmlAttrNotFoundError",
        LASSO_PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ => "LassoParamBadTypeOrNullObjError",
        LASSO_DS_ERROR_KEYS_MNGR_CREATION_FAILED => "LassoDsKeysMngrCreationFailedError",
        LASSO_DS_ERROR_CA_CERT_CHAIN_LOAD_FAILED => "LassoDsCaCertChainLoadFailedError",
        LASSO_WSF_PROFILE_ERROR_SOAP_FAULT => "LassoWsfprofileSoapFaultError",
        LASSO_PROFILE_ERROR_BUILDING_REQUEST_FAILED => "LassoProfileBuildingRequestFailedError",
        LASSO_PROFILE_ERROR_MISSING_SERVICE_TYPE => "LassoProfileMissingServiceTypeError",
        LASSO_DST_ERROR_NEW_DATA_MISSING => "LassoDstNewDataMissingError",
        LASSO_LOGIN_ERROR_STATUS_NOT_SUCCESS => "LassoLoginStatusNotSuccessError",
        LASSO_XML_ERROR_NODE_NOT_FOUND => "LassoXmlNodeNotFoundError",
        LASSO_NAME_IDENTIFIER_MAPPING_ERROR_FORBIDDEN_CALL_ON_THIS_SIDE => "LassoNameidentifiermappingForbiddenCallOnThisSideError",
        LASSO_XML_ERROR_ATTR_VALUE_NOT_FOUND => "LassoXmlAttrValueNotFoundError",
        LASSO_PROFILE_ERROR_INVALID_SOAP_MSG => "LassoProfileInvalidSoapMsgError",
        LASSO_PROFILE_ERROR_MISSING_SUBJECT => "LassoProfileMissingSubjectError",
        LASSO_PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE_ADDRESS => "LassoProfileMissingEndpointReferenceAddressError",
        LASSO_PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND => "LassoProfileNameIdentifierNotFoundError",
        LASSO_WSF_PROFILE_ERROR_MISSING_SECURITY => "LassoWsfprofileMissingSecurityError",
        LASSO_LOGOUT_ERROR_FEDERATION_NOT_FOUND => "LassoLogoutFederationNotFoundError",
        LASSO_XML_ERROR_OBJECT_CONSTRUCTION_FAILED => "LassoXmlObjectConstructionFailedError",
        LASSO_PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE => "LassoProfileMissingEndpointReferenceError",
        LASSO_NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_IDENTIFIER => "LassoNameidentifiermappingMissingTargetIdentifierError",
        LASSO_PROFILE_ERROR_INVALID_POST_MSG => "LassoProfileInvalidPostMsgError",
        LASSO_PROFILE_ERROR_BUILDING_MESSAGE_FAILED => "LassoProfileBuildingMessageFailedError",
        LASSO_XML_ERROR_INVALID_FILE => "LassoXmlInvalidFileError",
        LASSO_PROFILE_ERROR_MISSING_RESOURCE_OFFERING => "LassoProfileMissingResourceOfferingError",
        LASSO_PARAM_ERROR_CHECK_FAILED => "LassoParamCheckFailedError",
        LASSO_WSF_PROFILE_ERROR_MISSING_ASSERTION_ID => "LassoWsfprofileMissingAssertionIdError",
        LASSO_PROFILE_ERROR_MISSING_ENCRYPTION_PRIVATE_KEY => "LassoProfileMissingEncryptionPrivateKeyError",
        LASSO_WSF_PROFILE_ERROR_UNSUPPORTED_SECURITY_MECHANISM => "LassoWsfprofileUnsupportedSecurityMechanismError",
        LASSO_PROFILE_ERROR_MISSING_NAME_IDENTIFIER => "LassoProfileMissingNameIdentifierError",
        LASSO_LOGIN_ERROR_UNKNOWN_PRINCIPAL => "LassoLoginUnknownPrincipalError",
        LASSO_PROFILE_ERROR_MISSING_REQUEST => "LassoProfileMissingRequestError",
        LASSO_PROFILE_ERROR_INVALID_ARTIFACT => "LassoProfileInvalidArtifactError",
        LASSO_SOAP_ERROR_MISSING_ENVELOPE => "LassoSoapMissingEnvelopeError",
        LASSO_PROFILE_ERROR_IDENTITY_NOT_FOUND => "LassoProfileIdentityNotFoundError",
        LASSO_PROFILE_ERROR_INVALID_MSG => "LassoProfileInvalidMsgError",
        LASSO_PARAM_ERROR_INVALID_VALUE => "LassoParamInvalidValueError",
        LASSO_LOGIN_ERROR_CONSENT_NOT_OBTAINED => "LassoLoginConsentNotObtainedError",
        LASSO_DST_ERROR_QUERY_FAILED => "LassoDstQueryFailedError",
        LASSO_PROFILE_ERROR_MISSING_SERVICE_INSTANCE => "LassoProfileMissingServiceInstanceError",
        LASSO_DISCOVERY_ERROR_FAILED_TO_BUILD_ENDPOINT_REFERENCE => "LassoDiscoveryFailedToBuildEndpointReferenceError",
        LASSO_DS_ERROR_PUBLIC_KEY_LOAD_FAILED => "LassoDsPublicKeyLoadFailedError",
        LASSO_SERVER_ERROR_INVALID_XML => "LassoServerInvalidXmlError",
        LASSO_PROFILE_ERROR_MISSING_ASSERTION => "LassoProfileMissingAssertionError",
        LASSO_PROFILE_ERROR_UNKNOWN_PROFILE_URL => "LassoProfileUnknownProfileUrlError",
        LASSO_PROFILE_ERROR_INVALID_QUERY => "LassoProfileInvalidQueryError",
        LASSO_DEFEDERATION_ERROR_MISSING_NAME_IDENTIFIER => "LassoDefederationMissingNameIdentifierError",
        LASSO_PROFILE_ERROR_UNSUPPORTED_PROFILE => "LassoProfileUnsupportedProfileError",
        LASSO_DS_ERROR_SIGNATURE_VERIFICATION_FAILED => "LassoDsSignatureVerificationFailedError",
        LASSO_LOGIN_ERROR_REQUEST_DENIED => "LassoLoginRequestDeniedError",
        LASSO_DATA_SERVICE_ERROR_UNREGISTERED_DST => "LassoDataserviceUnregisteredDstError",
        LASSO_LOGIN_ERROR_INVALID_SIGNATURE => "LassoLoginInvalidSignatureError",
        LASSO_LOGIN_ERROR_UNSIGNED_AUTHN_REQUEST => "LassoLoginUnsignedAuthnRequestError",
        LASSO_SERVER_ERROR_SET_ENCRYPTION_PRIVATE_KEY_FAILED => "LassoServerSetEncryptionPrivateKeyFailedError",
        LASSO_DS_ERROR_SIGNATURE_TMPL_CREATION_FAILED => "LassoDsSignatureTmplCreationFailedError",
        LASSO_DISCOVERY_ERROR_SVC_METADATA_ASSOCIATION_ADD_FAILED => "LassoDiscoverySvcMetadataAssociationAddFailedError",
        LASSO_DS_ERROR_CONTEXT_CREATION_FAILED => "LassoDsContextCreationFailedError",
        LASSO_PROFILE_ERROR_MISSING_SERVICE_DESCRIPTION => "LassoProfileMissingServiceDescriptionError",
        LASSO_PROFILE_ERROR_MISSING_REMOTE_PROVIDERID => "LassoProfileMissingRemoteProvideridError",
        LASSO_PARAM_ERROR_NON_INITIALIZED_OBJECT => "LassoParamNonInitializedObjectError",
        LASSO_PROFILE_ERROR_MISSING_RESPONSE => "LassoProfileMissingResponseError",
        LASSO_LOGOUT_ERROR_REQUEST_DENIED => "LassoLogoutRequestDeniedError",
        LASSO_XML_ERROR_MISSING_NAMESPACE => "LassoXmlMissingNamespaceError",
        LASSO_PROFILE_ERROR_MISSING_ARTIFACT => "LassoProfileMissingArtifactError",
        LASSO_WSF_PROFILE_ERROR_MISSING_CORRELATION => "LassoWsfprofileMissingCorrelationError",
        LASSO_SERVER_ERROR_ADD_PROVIDER_PROTOCOL_MISMATCH => "LassoServerAddProviderProtocolMismatchError",
        LASSO_PROFILE_ERROR_MISSING_STATUS_CODE => "LassoProfileMissingStatusCodeError",
        LASSO_PROFILE_ERROR_BAD_IDENTITY_DUMP => "LassoProfileBadIdentityDumpError",
        LASSO_PROFILE_ERROR_BUILDING_RESPONSE_FAILED => "LassoProfileBuildingResponseFailedError",
        LASSO_LOGIN_ERROR_NO_DEFAULT_ENDPOINT => "LassoLoginNoDefaultEndpointError",
        LASSO_PROFILE_ERROR_BAD_SESSION_DUMP => "LassoProfileBadSessionDumpError",
        LASSO_DISCOVERY_ERROR_MISSING_REQUESTED_SERVICE => "LassoDiscoveryMissingRequestedServiceError",
        LASSO_SOAP_ERROR_MISSING_BODY => "LassoSoapMissingBodyError",
        LASSO_SERVER_ERROR_ADD_PROVIDER_FAILED => "LassoServerAddProviderFailedError",
        LASSO_PROFILE_ERROR_INVALID_HTTP_METHOD => "LassoProfileInvalidHttpMethodError",
        LASSO_PROFILE_ERROR_MISSING_ISSUER => "LassoProfileMissingIssuerError",
        LASSO_XML_ERROR_NODE_CONTENT_NOT_FOUND => "LassoXmlNodeContentNotFoundError",
        LASSO_SOAP_ERROR_MISSING_HEADER => "LassoSoapMissingHeaderError",
    );

    public static function throw_on_rc($rc) {
        $exception = self::$exceptions_dict[$rc];
        if (! class_exists($exception)) {
            $exception = "LassoError";
        }
        throw new $exception(strError($rc), $rc);
    }
}

?>
